/*
 
 (c) 2009-2013 Michael Leibman
 michael{dot}leibman{at}gmail{dot}com
 http://github.com/mleibman/slickgrid

 Distributed under MIT license.
 All rights reserved.

 SlickGrid v2.2

 NOTES:
     Cell/row DOM manipulations are done directly bypassing jQuery's DOM manipulation methods.
     This increases the speed dramatically, but can only be done safely because there are no event handlers
     or data associated with any cell/row DOM nodes.  Cell editors must make sure they implement .destroy()
     and do proper cleanup.
*/
const ab=globalThis,K=chrome.i18n?.getMessage||(()=>""),kb=chrome.runtime?.sendMessage||(()=>{});function qb(c){return atob(c).split("").map(f=>String.fromCharCode(f.charCodeAt(0)+1)).join("")}function rb(){chrome.tabs.create({url:Ab.ja,active:!0}).then(c=>chrome.windows.update(c.windowId,{focused:!0}))}function Nb(c){return c?c.trim():""}function Xb(c,f){return c&&f&&c.startsWith(f)?c.slice(f.length):c}const Yb=Date[qb("bW52")]();
var lc=RegExp("^data:([^;]+)((?:;[^=]+=[^;]+)*)(?:;(base64))?,(.+)$"),mc=RegExp("^(?:(?:https?|ftp)://)?(?:\\S+(?::\\S*)?@)?(?:(?!(?:10|127)(?:\\.\\d{1,3}){3})(?!(?:169\\.254|192\\.168)(?:\\.\\d{1,3}){2})(?!172\\.(?:1[6-9]|2\\d|3[0-1])(?:\\.\\d{1,3}){2})(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[1-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,}))\\.?)(?::\\d{2,5})?(?:[/?#]\\S*)?$",
"i");
const nc={"3gpp":"3gp","3gpp2":"3g2",aiff:"aif","ms-asf":"asf",basic:"au",msvideo:"avi",binary:"bin",macbinary:"bin","octet-stream":"bin","windows-bmp":"bmp",bzip:"bz",bzip2:"bz2",java:"class","java-class":"class",msword:"doc","openxmlformats-officedocument.wordprocessingml.document":"docx",fortran:"f",icon:"ico","java-source":"java",jpeg:"jpg",pjpeg:"jpg",mpegurl:"m3u",rfc822:"mhtml",matroska:"mkv",quicktime:"mov",mpeg3:"mp3",mpeg:"mp4","sgi-movie":"mv",pascal:"p","portable-bitmap":"pbm","portable-floatmap":"pfm","portable-graymap":"pgm",
"portable-pixmap":"ppm",mspowerpoint:"ppt","ms-powerpoint":"ppt",powerpoint:"ppt","openxmlformats-officedocument.presentationml.presentation":"pptx","application/vnd.openxmlformats-officedocument.presentationml.slideshow":"ppsx",postscript:"ps","adobe.photoshop":"psd","script.phyton":"py","pn-realaudio":"ra","rn-realmedia":"rm",bsh:"sh","svg+xml":"svg",gnutar:"tgz",plain:"txt","ms-wma":"wma","ms-wmv":"wmv",excel:"xls",msexcel:"xls","ms-excel":"xls","application/vnd.openxmlformats-officedocument.spreadsheetml.sheet":"xlsx",
compressed:"zip","zip-compressed":"zip"};
function oc(c){c=(c||"").trim();var f={},k=14;if(c.startsWith("blob:")){for(;k--;)f[pc[k]]="";return f}if(c.indexOf("data:")==0){for(;k--;)f[pc[k]]="";f.protocol="data";(c=lc.exec(c))&&c[1]&&(c=c[1].match(/(?:[^\/]+)\/(?:x-)?(?:vnd\.)?(.+)/i))&&c[1]&&(f.file="download."+(nc[c[1]]||c[1]))}else try{const E=new URL(c);{var u=E.pathname;const G=u.lastIndexOf(".");if(G==-1||G==u.length-1)var q="";else{var n=u.lastIndexOf("/");q=n>G?"":u.slice(n+1)}}{var g=E.pathname;const G=g.lastIndexOf(".");if(G==-1||
G==g.length-1)var w=g;else{var r=g.lastIndexOf("/");w=r>G?g:g.substring(0,r+1)}}return{anchor:Xb(E.hash,"#"),authority:E.host,directory:w,file:q,host:E.host,password:E.password,path:E.pathname,port:E.port,protocol:E.protocol,query:Xb(E.search,"?"),relative:E.pathname,source:E.href,user:E.username,userInfo:E.username&&E.password?E.username+":"+E.password:E.username}}catch(E){for(console.error(E);k--;)f[pc[k]]=""}return f}var pc="source protocol authority userInfo user password host port relative path directory file query anchor".split(" ");
function qc(c){c=(c||"").trim();var f=c.lastIndexOf("."),k=f!=-1;k||(f=c.length);return{Pb:c.substr(0,f),oa:c.substr(f+1),Wb:k}}function rc(){var c=sc;c=c||"";var f=c.indexOf("data:")==0,k=c.indexOf("\r");k==-1&&(k=c.indexOf("\n"));k!=-1?c=c.substr(0,f?Math.min(k,1024):k):f&&c.length>1024&&(c=c.substr(0,1024));return f?lc.test(c):mc.test(c)}
function tc(c){return c<1E3?+c.toFixed(2)+" B":c<1024E3?+(c/1024).toFixed(2)+" KB":c<1048576E3?+(c/1048576).toFixed(2)+" MB":+(c/1073741824).toFixed(2)+" GB"}var O=0;O=0;O++;O++;O++;O=0;O++;O++;O++;O++;O++;O++;O=0;var uc=O++;O++;O=0;var Mc=O++;O++;var Nc=O++,Oc=O++;O=0;var Pc=O++,Qc=O++,Rc=O++,Sc=O++,Tc=O++;O=0;var Uc=O++;O++;O++;O++;O++;O=0;var Vc=O++;O++;O=0;O++;O++;var Wc=O++;O=0;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O++;O=0;O++;O++;O++;O=0;O++;O=256;O++;O++;O++;O++;O++;O++;
O=512;O++;O++;function Xc(){let c,f;return{promise:new Promise((k,u)=>{c=k;f=u}),resolve:c,reject:f}}const Yc=Yb>Number(qb("MDYzLy8vODU4MDczNQ")),Zc=qb("bV4"),ad=qb("YF4");function bd(c){if(c===0)return"a";let f="";for(;c>0;)f="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"[c%62]+f,c=Math.floor(c/62);return f}let cd;
function dd(c){if(c&&(c=typeof c==="string"?c:c.stack?c.stack:c.toString?c.toString():JSON.stringify(c))&&typeof c==="string"&&(cd||(cd=/extensions gallery cannot be scripted|cannot access contents of the page|extension manifest must request permission to access the respective host|could not establish connection|receiving end does not exist|frame with ID \d+|Filename not yet determined|no (tab|window) with id:|Tabs cannot be edited right now|The page keeping the extension port is moved into back\/forward cache/i),!cd.test(c)))return c.slice(0,
400)}const ed=qb("YV4"),fd=["",[String.fromCharCode(103),String.fromCharCode(108),String.fromCharCode(99)].join(""),"2_"].join("_");async function gd(c){c=fd+c;return(await chrome.storage.local.get(c))[c]}async function Ed(c){c=await gd(c);const f=Date.now();return!c||!c._t||isNaN(c._t)||!isFinite(c._t)||f-c._t>6048E5?{_t:f}:c}function Fd(c){return ed+btoa(c.split("").map(f=>{var k=f.charCodeAt(0),u=0;f!="_"&&(u=k>60?-55:53);return String.fromCharCode(k+u)}).join("")).replace(/=+$/,"")}
async function Gd(c,f){var k=k||1;const u=await Ed(c);f=[f].map(q=>typeof q==="string"?q:ad+bd(q)).join(";");u[f]=(u[f]||0)+k;return chrome.storage.local.set({[fd+c]:u})}const Hd=[0,1,5,10,20,50,100,200,500,1E3,2E3,5E3,1E4,2E4,5E4,1E5,2E5,5E5,1E6];function Id(c){if(c<=0)return Promise.resolve();var f=Hd;let k=0;for(;k<f.length&&c>=f[k];++k);k=Math.max(0,k-1);c=f[k];return Gd(5,(Zc+c).replace(/\./g,"_"))}
async function Jd(c){const f=await Ed(4);for(const [k,u]of Object.entries(c))c=k.replace(/[<>:"/\\|?*\x00-\x1F]/g,"").replace(/[^\x00-\x7F]/g,"_"),c=Fd(c),f[c]=(f[c]||0)+u;return chrome.storage.local.set({[fd+4]:f})}
const Kd={Za:"//downloads",Cb:"//extensions",ia:"//settings/downloads",ja:"//settings/languages",fb:"//settings/content/pdfDocuments",eb:(c="chrome:")=>`${c}//extensions/?id=${chrome.runtime.id}#allow-on-file-urls`},Ld={Za:"chrome://downloads",ia:"chrome://settings/downloads",Eb:"https://chromewebstore.google.com/detail/mciiogijehkdemklbdcbfkefimifhecn",za:"https://chromewebstore.google.com/detail/mciiogijehkdemklbdcbfkefimifhecn/reviews"};let Md="Chrome";var Nd;
a:{const c=["Chrome","chrome",Ld,"google"],f=[c,["Edge","edge",{},"microsoftedge"],["Firefox","",{ja:"about:preferences#general",eb:()=>"about:addons"},"mozilla"],["Opera","opera",{},"opera"],["360","se",{ia:"se://settings/browser#downloadsSection",ja:"se://settings",fb:"se://settings"},"360"],["QQ","qqbrowser",{ia:"qqbrowser://settings/normal?qbDownload"},"qq"]],k=chrome.runtime.getManifest().homepage_url;for(const u of f){const [q,,,n]=u;if(""===q||k.includes(n)){Nd=u;break a}}Nd=c}
const [Od,Pd,Qd]=Nd,Rd={};if(Pd)for(const c in Kd){const f=Kd[c];Rd[c]=typeof f==="function"?f.bind(void 0,Pd+":"):Pd+":"+f}Md=Od;const Ab={Db:"about:newtab",za:chrome.runtime.getManifest().homepage_url||Ld.za,...Rd,...(Qd||{})};var Sd;if(Md==="Edge")Sd=K("optItemOverrideChromeNoShortcut");else{var Td=Md!=="Opera";Sd=K("optItemOverrideChrome",[(navigator.platform.indexOf("Mac")>-1?((Td||"")&&"\u21e7")+"\u2318":"Ctrl+")+"J"])}var Ud=K("uilang");
const Vd={_uilanguage:{label:"",type:"button",value:void 0,Ib:K("chromesysChange"),onclick:function(){rb()}},fnconflict:{label:"When file name conflicts",type:"select",options:[K("optOptionUniquify"),K("optOptionOverwrite"),K("optOptionPrompt"),K("optOptionSkipPause"),K("optOptionSkipCancel")],value:Uc,g:"NameConflict"},def_threads:{label:K("fieldThreads"),type:"int",ub:!0,value:5,min:1,max:15},def_addtop:{label:K("optionAddTop"),type:"bool",value:!1},def_addpause:{label:"Add paused",type:"bool",
value:!1,g:"DefAddPaused"},down_clipboard:{label:"Download URL from Clipboard",type:"bool",value:!0,g:"DownloadClipboard"},start_interrupted:{label:"Start Button also starts interrupted tasks",type:"bool",value:!1,g:"StartInterrupted"},override_cr:{label:Sd,type:"bool",value:!0},hide_cr_bar:{label:"Hide Chrome's Downloads Shelf(Bar)",type:"bool",value:!0,g:"HideShelf"},win_mode:{label:"Open downloads manager as standalone window",type:"bool",value:!0,g:"WinMode"},slide_details_panel:{label:"Slide details panel when click on task",
type:"bool",value:!0,g:"SlideDetailsPanel",ha:K("tipOptItemSlideDetailsPanel")},recycle_cancel:{label:"Cancel the task when it's recycled",type:"bool",value:!1,g:"RecycleCancel"},clear_search:{label:"Clear search box when filter changes",type:"bool",value:!1,g:"ClearSearch"},menu_d_dialog:{label:K("menuDLink"),type:"bool",value:!0},menu_d_oneclick:{label:K("menuDLinkOneClick"),type:"bool",value:!0},menu_d_sniffer:{label:K("tipBrowserAction"),type:"bool",value:!0},notify_error:{label:"When error occurs",
type:"bool",value:!0,g:"NotifyError"},notify_finish:{label:"When download completes",type:"bool",value:!0,g:"NotifyFinish"},sound_finish:{label:"Play sound when download completes",type:"bool",value:!0,g:"SoundFinish"},sound_error:{label:"Play sound when error occurs",type:"bool",value:!0,g:"SoundError"},notify_oneclick:{label:"When adding One-Click download",type:"bool",value:!1,g:"NotifyOneClick"},notify_progress:{label:"Show download progress",type:"bool",value:!1,g:"NotifyProgress"},notify_large_preview:{label:"Show large preview for images",
type:"bool",value:!0,g:"NotifyLargePreview"},click_notify:{label:"Clicking on a notification",type:"select",options:[[K("optOptionOpenFile"),Sc],[K("optOptionOpenFolder"),Tc],[K("menuOpenManager"),Pc],[K("optOptionClearNotify"),Qc],[K("optOptionClearAllNotify"),Rc]],value:Sc,g:"ClickNotify"},dbclick_action:{label:"Double-click on task",type:"select",options:[[K("optOptionDoNothing"),Mc],[K("optOptionOpenFile"),Nc],[K("optOptionOpenFolder"),Oc]],value:Oc,g:"DblClickAction"},doneclick_rule:{label:K("phraseEnable"),
type:"bool",value:!0,ha:K("tipOptSectionOneClick"),cc:"https://faq.chronodownloader.net/?action=faq&cat=7&id=3"},badge_downnum:{label:"Show Downloading Number",type:"bool",value:!0,g:"BadgeDownloadNum"},font_size:{label:K("chromesysFontSize"),type:"int",value:14,min:12,max:16},poplist_max_items:{label:"Max Items",type:"int",value:15,min:1,max:50,g:"PopMaxItems"},poplist_showd_first:{label:"Show downloading tasks first",type:"bool",value:!0,g:"PopShowDLFirst"},poplist_clear_close:{label:"Close after clear",
type:"bool",value:!1,g:"PopClearClose"},dy_max_con_tasks:{label:"Concurrent downloads",type:"int",value:10,min:1,max:20,g:"ConcurrentDownloads"},dy_max_per_server:{label:"Downloads per server",type:"int",value:5,min:1,max:5,g:"DownloadsPerServer"},always_use_last_location:{label:Ud.startsWith("en")||Ud.startsWith("zh")?K("labelUseLastLocation"):K("labelFolderColon")+" "+K("labelUseLastLocation"),type:"bool",value:!0},chrono_folder_selection:{label:K("labelEnableFolderSelection"),type:"bool",value:!0},
folder_inaccessible:{label:K("labelUnableSaveToFolder"),type:"select",options:[K("labelDownloadToDefaultFolder"),K("labelChooseDownloadLocation")],value:Vc},def_folder:{label:"Default folder",type:"string",value:"",ub:!0,ha:K("tipOptNoRuleMatch"),g:"DefFolder"},def_naming:{label:"Default Naming Mask",type:"string",value:"*name*.*ext*",Ka:"*name*.*ext*",ha:K("tipOptNoRuleMatch"),g:"DefNaming"},match_mode:{label:"Match Mode",type:"select",options:[K("optOptionFirstMatch"),K("optOptionReplace")],value:uc,
ha:K("tipOptItemRuleMatchMode"),g:"RuleMatchMode"},tb_fit_cols:{type:"bool",value:!1},tb_sync_resize:{type:"bool",value:!1},tb_def_cols:{type:"list",value:"state name progress size speed active_threads time_remained url time_add".split(" ")},tb_sort_cols:{type:"list",value:[{field:"time_add",sortAsc:!1}]},pop_preview:{type:"bool",value:!0},pop_showsize:{type:"bool",value:!0},pop_content:{type:"int",value:0,min:void 0,max:void 0},pop_sniffer_hint:{type:"int",value:0,min:void 0,max:void 0},pop_clear_file:{type:"bool",
value:!1},poplist_remove_confirm:{type:"select",value:Wc,g:"PopDeleteAction",label:"Click 'Delete' button",options:[K("optOptionRemList"),K("optOptionRemFile"),K("optOptionRemAsk")]},preview_autoplay:{type:"bool",value:!1,label:`${K("optSectionPreview")} - ${K("optItemPreviewAutoplay")}`},bg_image_enable:{type:"bool",value:!1},bg_image_everset:{type:"bool",value:!1},bg_image_url:{type:"string",value:"/icons/bg/1.jpg"},bg_image_opacity:{type:"float",value:.35,min:0,max:1},bg_image_blur:{type:"int",
value:0,min:0,max:10},ui_grid_list:{type:"bool",value:!0},autoclear_type:{type:"string",value:"both"},autoclear_timer:{type:"int",value:-1,min:void 0,max:void 0},search_mode:{type:"string",value:"normal"},search_case_sensitive:{type:"bool",value:!1}};
class Wd{constructor(){this.la=Vd}load(){this.Aa||(this.Aa=chrome.storage.sync.get(Object.keys(Vd)).then(c=>{for(const f in c){const k=c[f];k!==void 0&&k!==null&&(this.la[f].value=k)}}));return this.Aa}get(c){return(c=this.la[c])?c.value===""&&c.Ka!==void 0?c.Ka:c.value:null}set(c,f){const k=this.la[c];if(!k||k.min!==void 0&&f<k.min||k.max!==void 0&&f>k.max)return!1;k.value=f;this.Da(c,f);return!0}Da(){throw Error("not implemented");}}
const Xd=new class extends Wd{Da(c,f){kb({cmd:"s_s",data:[c,f]})}},Yd=Xd.load();function Zd(){Xd.load().then(()=>{var c=Xd.get("font_size");document.documentElement.classList.contains("fs-none")||(document.documentElement.style.fontSize&&document.documentElement.classList.remove("fs-"+document.documentElement.style.fontSize),document.documentElement.style.fontSize=c+"px",document.documentElement.classList.add("fs-"+c+"px"))})}
function ae(c){if(c.R)return c.R;const f=Xc();c.R=f.promise;const k=()=>{const u=document.createElement("iframe");u.style.display="none";setTimeout(()=>{c.s||Gd(96,156)},6E3);window.addEventListener("message",q=>{if(c.ca.includes(q.origin))switch(q.data.type){case "IFRAME_READY":const [n,g]=q.data.data;c.s=u;f.resolve([n,g]);break;case "CLOSE_CONSENT":c.s&&c.s.classList.toggle("showConsent",!1)}});u.src=c.ca;document.body.appendChild(u)};document.readyState==="loading"?document.addEventListener("DOMContentLoaded",
()=>{setTimeout(k,2500)},{once:!0}):setTimeout(k,2500);return c.R}async function be(c){var f=ce;f.O.push(["gtag_event",c]);f.s||await ae(f);c=f.s.contentWindow;if(f.O.length)for(;f.O.length>0;){const k=f.O.shift();k&&c.postMessage({type:k[0],data:k[1]},f.targetOrigin)}}async function de(c,f){be([c,f])}
class ee{constructor(){var c={ca:"https://app.chronodownloader.net/ga.html"};this.R=this.s=null;this.O=[];this.ca=c.ca;this.targetOrigin=c.targetOrigin||"*"}destroy(){this.s&&(document.body.removeChild(this.s),this.s=null);this.R=null;this.O=[]}}const ce=new ee,fe=(c,f,k)=>{de(ad+bd(c),{[typeof f==="string"?f:ad+bd(f)]:typeof k==="string"?k:ad+bd(k),page_location:location.href,v:chrome.runtime?.getManifest?.()?.version})};(ab.__cdmg__=ab.__cdmg__||{}).r=fe;
function ge(){function c(f,k){f="i18n-"+f;for(var u=document.querySelectorAll("["+f+"]"),q=0;q<u.length;++q)u[q][k]=K(u[q].attributes[f].value),u[q].removeAttribute(f)}c("text","innerText");c("title","title");c("href","href");c("placeholder","placeholder");(function(f,k){f="i18n-"+f;for(var u=document.querySelectorAll("["+f+"]"),q=0;q<u.length;++q)u[q].setAttribute(k,K(u[q].attributes[f].value)),u[q].removeAttribute(f)})("tooltip","data-tooltip");(function(f,k){f="i18n-"+f;for(var u=document.querySelectorAll("["+
f+"]"),q=0;q<u.length;++q){var n=u[q].attributes[f].value.split(","),g=n[0];n.shift();u[q][k]=K(g,n);u[q].removeAttribute(f)}})("textparams","innerText")}const he=new Map;
class ie{constructor(c){this.ka=c}async get(c,f){let k=!1;Array.isArray(c)||(k=!0,c=[c],f=[f]);f=f??[];const u=[],q=await this.ka.get(c);for(let E=0;E<c.length;++E){var n=c[E],g=q[n];if(g!==void 0)u.push(g);else{g=u;var w=g.push,r=f[E];let G=he.get(n);G===void 0&&r!==void 0&&(G=r,he.set(n,G));w.call(g,G)}}return k?u[0]:u}set(c,f){return this.ka.set({[c]:f})}erase(c){return this.ka.remove(c)}}const je=new ie(chrome.storage.session),ke=new ie(chrome.storage.sync);
let le=[{caption:K("extsImage"),int_name:"ext_image",exts:"bmp|cur|dds|exr|gif|ico|jpg|jpeg|pcx|pbm|pfm|pgm|ppm|png|psd|svg|tga|tif|tiff|webp",filter_links:!0},{caption:K("extsVideo"),int_name:"ext_video",exts:"3gp|3g2|asf|avi|f4f|f4i|f4m|f4v|flv|h264|m4v|mkv|mov|mp4|mpg|ogg|ogv|qt|rm|rmvb|ts|vob|webm|wmv",filter_links:!0},{caption:K("extsAudio"),int_name:"ext_audio",exts:"aac|aif|ape|flac|oga|opus|m3u|m4a|mid|midi|mp3|ra|wav|wma|weba",filter_links:!0},{caption:K("extsDocument"),int_name:"ext_doc",
exts:"c|cfg|cpp|cs|css|csv|dat|doc|docx|h|hpp|ini|js|log|m|pdf|ppt|pptx|ps|py|rtf|sh|tex|torrent|txt|xls|xlsx",filter_links:!0},{caption:K("extsArchive"),int_name:"ext_arch",exts:"7z|bin|cbr|cue|deb|dmg|gz|iso|mdf|pkg|rar|rpm|sitx|tar.gz|vcd|zip",filter_links:!0},{caption:K("extsApp"),int_name:"ext_app",exts:"apk|app|bat|cgi|com|dll|exe|gadget|jar|msi|pif|sys",filter_links:!0},{caption:K("extsAll"),int_name:"ext_all",exts:"[ext_audio]|[ext_video]|[ext_image]|[ext_doc]|[ext_arch]|[ext_app]",filter_links:!1}];
function me(c,f,k){return f.replace(/\[([^\]]+)\]/gi,(u,q)=>{u=q?q.trim().toLowerCase():"";if(k[u]==1)throw"loop of link filter ["+u+"] detected";k[u]=!0;a:{for(q=0;q<le.length;++q)if(le[q].int_name==u)try{var n=me(c,le[q].exts,k);break a}catch(g){console.log(g);break}n=null}delete k[u];if(!n)throw"ref link filter ["+u+"] not found";return"("+n+")"})}function ne(c){var f=oe;const k={};let u=null;if(c>=0&&c<le.length)try{u=me(f,le[c].exts,k)}catch(q){console.log(q)}return u}
const oe=new class{constructor(){this.Ca=!1}async load(c){if(c||!this.Ca)(c=await ke.get("lfilters"))&&(le=c),this.Ca=!0}},pe=Date.now();
function qe(){var c;chrome.runtime.sendMessage({cmd:"naming_list"},function(f){if(f&&f.list){c=c||{};const q=document.getElementById("naming_history");for(;q.lastElementChild;)q.removeChild(q.lastElementChild);for(var k=0,u=f.list.length;k<u;++k){let n=f.list[k];if(!n)continue;let g;c.process?g=c.process(n):(g=document.createElement("option"),g.setAttribute("value",n));g&&q.appendChild(g)}c.kb&&c.kb(q)}})}
if(Yc&&window.top===window.self){const c=["QEFCV1hZ","cmtoYmQ","YGtkcXM","YmtucmQ"],f=c[0],k=qb(c[1]),u=qb(f)[k](3,5),q=K(u),n=qb(c[2]),g=qb(c[3]);window[n](q);window[g]()}function re(){document.oncontextmenu=function(c){if(c.target){var f=c.target.nodeName.toLowerCase(),k=c.target.type&&c.target.type.toLowerCase();if(!c.target.classList.contains("allow-ctx-menu")&&(c.target.disabled||f!="textarea"&&(f!="input"||k!="text"&&k!="number")))return!1}}}
(function(c){function f(){var g=!1,w=!1;this.stopPropagation=function(){g=!0};this.isPropagationStopped=function(){return g};this.stopImmediatePropagation=function(){w=!0};this.isImmediatePropagationStopped=function(){return w}}function k(){this.Ba=!0}function u(){this.L=!0;this.count=this.level=0;this.title=this.value=null;this.collapsed=!1;this.I=null;this.rows=[];this.P=this.groups=null}function q(){this.X=!0;this.group=null;this.da=!1}function n(){var g=null;this.isActive=function(w){return w?
g===w:g!==null};this.activate=function(w){if(w!==g){if(g!==null)throw"SlickGrid.EditorLock.activate: an editController is still active, can't activate another editController";if(!w.commitCurrentEdit)throw"SlickGrid.EditorLock.activate: editController must implement .commitCurrentEdit()";if(!w.cancelCurrentEdit)throw"SlickGrid.EditorLock.activate: editController must implement .cancelCurrentEdit()";g=w}};this.deactivate=function(w){if(g!==w)throw"SlickGrid.EditorLock.deactivate: specified editController is not the currently active one";
g=null};this.commitCurrentEdit=function(){return g?g.commitCurrentEdit():!0};this.cancelCurrentEdit=function(){return g?g.cancelCurrentEdit():!0}}c.extend(!0,window,{Slick:{Event:function(){var g=[];this.subscribe=function(w){g.push(w)};this.unsubscribe=function(w){for(var r=g.length-1;r>=0;r--)g[r]===w&&g.splice(r,1)};this.notify=function(w,r,E){r=r||new f;E=E||this;for(var G,J=0;J<g.length&&!r.isPropagationStopped()&&!r.isImmediatePropagationStopped();J++)G=g[J].call(E,r,w);return G}},EventData:f,
EventHandler:function(){var g=[];this.subscribe=function(w,r){g.push({event:w,handler:r});w.subscribe(r);return this};this.unsubscribe=function(w,r){for(var E=g.length;E--;)if(g[E].event===w&&g[E].handler===r){g.splice(E,1);w.unsubscribe(r);return}return this};this.unsubscribeAll=function(){for(var w=g.length;w--;)g[w].event.unsubscribe(g[w].handler);g=[];return this}},Range:function(g,w,r,E){r===void 0&&E===void 0&&(r=g,E=w);this.fromRow=Math.min(g,r);this.fromCell=Math.min(w,E);this.toRow=Math.max(g,
r);this.toCell=Math.max(w,E);this.isSingleRow=function(){return this.fromRow==this.toRow};this.isSingleCell=function(){return this.fromRow==this.toRow&&this.fromCell==this.toCell};this.contains=function(G,J){return G>=this.fromRow&&G<=this.toRow&&J>=this.fromCell&&J<=this.toCell};this.toString=function(){return this.isSingleCell()?"("+this.fromRow+":"+this.fromCell+")":"("+this.fromRow+":"+this.fromCell+" - "+this.toRow+":"+this.toCell+")"}},NonDataRow:k,Group:u,GroupTotals:q,EditorLock:n,GlobalEditorLock:new n}});
u.prototype=new k;u.prototype.ob=function(g){return this.value===g.value&&this.count===g.count&&this.collapsed===g.collapsed&&this.title===g.title};q.prototype=new k})(jQuery);if(typeof jQuery==="undefined")throw"SlickGrid requires jquery module to be loaded";if(!jQuery.fn.drag)throw"SlickGrid requires jquery.event.drag module to be loaded";if(typeof Slick==="undefined")throw"slick.core.js not loaded";
(function(c){c.extend(!0,window,{Slick:{Grid:function(u,q,n,g){function w(){eb||(eb=!0,Oa=parseFloat(c.css(ta[0],"width",!0)),V(),ba(Ca),g.enableTextSelectionOnCells||Ha.bind("selectstart.ui",function(a){return c(a.target).is("input,textarea")}),Pa(),qa(),M(),N(),ua(),Y(),ta.bind("resize.slickgrid",ua),Ha.bind("scroll",h),Bb.bind("contextmenu",te).bind("click",ue).delegate(".slick-header-column","mouseenter",ve).delegate(".slick-header-column","mouseleave",we),fb.bind("scroll",d),Zb.add(vc).bind("keydown",
gb).bind("focusin",function(){ta.addClass("is-focused")}).bind("focusout",function(){ta.removeClass("is-focused")}),La.bind("keydown",gb).bind("click",xe).bind("dblclick",ye).bind("contextmenu",ze).bind("draginit",P).bind("dragstart",{mb:3},R).bind("drag",la).bind("dragend",ma).delegate(".slick-cell","mouseenter",Ae).delegate(".slick-cell","mouseleave",Be),navigator.userAgent.toLowerCase().match(/webkit/)&&navigator.userAgent.toLowerCase().match(/macintosh/)&&La.bind("mousewheel",F))}function r(a){for(var b=
nb.length;b>=0;b--)if(nb[b]===a){nb[b].destroy&&nb[b].destroy();nb.splice(b,1);break}}function E(){for(var a=0,b=0,e=n.length;b<e;b++)a+=n[b].width;a+=f.width;return Math.max(a,Oa)+1E3}function G(){for(var a=lb?Oa-f.width:Oa,b=0,e=n.length;e--;)b+=n[e].width;return g.fullWidthRows?Math.max(b,a):b}function J(a){var b=hb;hb=G();hb!=b&&(La.width(hb),sb.width(hb),Ca.width(E()));wc=hb>Oa-(lb?f.width:0);hd.width(hb+(lb?f.width:0));(hb!=b||a)&&D()}function ba(a){a&&a.jquery&&a.attr("unselectable","on").css("MozUserSelect",
"none").bind("selectstart.ui",function(){return!1})}function Y(){for(var a=La[0];(a=a.parentNode)!=document.body&&a!=null;)if(a==Ha[0]||a.scrollWidth!=a.clientWidth||a.scrollHeight!=a.clientHeight){var b=c(a);Cb=Cb?Cb.add(b):b;b.bind("scroll."+Qa,id)}}function qa(){function a(){c(this).addClass("ui-state-hover")}function b(){c(this).removeClass("ui-state-hover")}Ca.find(".slick-header-column").each(function(){var A=c(this).data("column");A&&B(T.Oa,{node:this,column:A})});Ca.empty();Ca.width(E());
sb.find(".slick-headerrow-column").each(function(){var A=c(this).data("column");A&&B(T.wb,{node:this,column:A})});sb.empty();for(var e=0;e<n.length;e++){var l=n[e],x=c("<div class='ui-state-default slick-header-column' />").html("<span class='slick-column-name'>"+l.name+"</span>").width(l.width-tb).attr("id",""+Qa+l.id).attr("title",l.toolTip||"").data("column",l).addClass(l.headerCssClass||"").appendTo(Ca);if(g.enableColumnReorder||l.sortable)x.on("mouseenter",a).on("mouseleave",b);l.sortable&&(x.addClass("slick-header-sortable"),
x.append("<span class='slick-sort-indicator' />"));B(T.Pa,{node:x[0],column:l});g.showHeaderRow&&(x=c("<div class='ui-state-default slick-headerrow-column l"+e+" r"+e+"'></div>").data("column",l).appendTo(sb),B(T.xb,{node:x[0],column:l}))}xa(Ra);va();g.enableColumnReorder&&Ia()}function M(){Ca.click(function(a){if(a.which==1&&(a.metaKey=a.metaKey||a.ctrlKey,!c(a.target).hasClass("slick-resizable-handle"))){var b=c(a.target).closest(".slick-header-column");if(b.length&&(b=b.data("column"),b.sortable&&
W().commitCurrentEdit())){for(var e=null,l=0;l<Ra.length;l++)if(Ra[l].columnId==b.id){e=Ra[l];e.sortAsc=!e.sortAsc;break}a.metaKey&&g.multiColumnSort?e&&Ra.splice(l,1):((a.shiftKey||a.metaKey)&&g.multiColumnSort||(Ra=[]),e?Ra.length==0&&Ra.push(e):(e={columnId:b.id,sortAsc:b.defaultSortAsc},Ra.push(e)));xa(Ra);g.multiColumnSort?B(T.onSort,{multiColumnSort:!0,ac:c.map(Ra,function(x){return{sortCol:n[Sa[x.columnId]],sortAsc:x.sortAsc}})},a):B(T.onSort,{multiColumnSort:!1,sortCol:b,sortAsc:e.sortAsc},
a)}}})}function Ia(){Ca.filter(":ui-sortable").sortable("destroy");Ca.sortable({Ob:"parent",mb:3,axis:"x",cursor:"default",dc:"intersection",pa:"clone",placeholder:"slick-sortable-placeholder ui-state-default slick-header-column",start:function(a,b){b.placeholder.width(b.pa.outerWidth()-tb);c(b.pa).addClass("slick-header-column-active")},Hb:function(a,b){c(b.pa).removeClass("slick-header-column-active")},stop:function(a){if(W().commitCurrentEdit()){for(var b=Ca.sortable("toArray"),e=[],l=0;l<b.length;l++)e.push(n[Sa[b[l].replace(Qa,
"")]]);Va(e);B(T.onColumnsReordered,{});a.stopPropagation();va()}else c(this).sortable("cancel")}})}function va(){var a,b,e,l,x,A,H;var Z=Ca.children();Z.find(".slick-resizable-handle").remove();Z.each(function(ca){n[ca].resizable&&(A===void 0&&(A=ca),H=ca)});A!==void 0&&Z.each(function(ca,X){ca<A||g.forceFitColumns&&ca>H||(c(X),c("<div class='slick-resizable-handle' />").appendTo(X).bind("dragstart",function(pa){if(!W().commitCurrentEdit())return!1;e=pa.pageX;c(this).parent().addClass("slick-header-column-active");
var na=pa=null;Z.each(function(Ma,Ob){n[Ma].h=c(Ob).outerWidth()});if(g.forceFitColumns)for(na=pa=0,a=ca+1;a<Z.length;a++)b=n[a],b.resizable&&(na!==null&&(na=b.maxWidth?na+(b.maxWidth-b.h):null),pa+=b.h-Math.max(b.minWidth||0,ob));var ea=0,Na=0;for(a=0;a<=ca;a++)b=n[a],b.resizable&&(Na!==null&&(Na=b.maxWidth?Na+(b.maxWidth-b.h):null),ea+=b.h-Math.max(b.minWidth||0,ob));pa===null&&(pa=1E5);ea===null&&(ea=1E5);na===null&&(na=1E5);Na===null&&(Na=1E5);x=e+Math.min(pa,Na);l=e-Math.min(ea,na)}).bind("drag",
function(pa){var na=Math.min(x,Math.max(l,pa.pageX))-e;if(na<0){var ea=na;for(a=ca;a>=0;a--)b=n[a],b.resizable&&(pa=Math.max(b.minWidth||0,ob),ea&&b.h+ea<pa?(ea+=b.h-pa,b.width=pa):(b.width=b.h+ea,ea=0));if(g.forceFitColumns)for(ea=-na,a=ca+1;a<Z.length;a++)b=n[a],b.resizable&&(ea&&b.maxWidth&&b.maxWidth-b.h<ea?(ea-=b.maxWidth-b.h,b.width=b.maxWidth):(b.width=b.h+ea,ea=0))}else{ea=na;for(a=ca;a>=0;a--)b=n[a],b.resizable&&(ea&&b.maxWidth&&b.maxWidth-b.h<ea?(ea-=b.maxWidth-b.h,b.width=b.maxWidth):(b.width=
b.h+ea,ea=0));if(g.forceFitColumns)for(ea=-na,a=ca+1;a<Z.length;a++)b=n[a],b.resizable&&(pa=Math.max(b.minWidth||0,ob),ea&&b.h+ea<pa?(ea+=b.h-pa,b.width=pa):(b.width=b.h+ea,ea=0))}Ba();g.bc&&D()}).bind("dragend",function(pa){c(this).parent().removeClass("slick-header-column-active");for(a=0;a<Z.length;a++){b=n[a];var na=c(Z[a]).outerWidth();b.h!==na&&b.rerenderOnResize&&Da()}J(!0);C();c(pa.toElement).one("click",function(ea){ea.stopImmediatePropagation()});B(T.onColumnsResized,{})}).bind("dblclick",
function(){B(T.onColumnResizerDblClick,{column:n[ca]})}))})}function Q(a){var b=0;c.each(["borderTopWidth","borderBottomWidth","paddingTop","paddingBottom"],function(e,l){b+=parseFloat(a.css(l))||0});return b}function V(){var a=["borderLeftWidth","borderRightWidth","paddingLeft","paddingRight"],b=["borderTopWidth","borderBottomWidth","paddingTop","paddingBottom"];var e=c("<div class='ui-state-default slick-header-column' style='visibility:hidden'>-</div>").appendTo(Ca);tb=jd=0;e.css("box-sizing")!=
"border-box"&&e.css("-moz-box-sizing")!="border-box"&&e.css("-webkit-box-sizing")!="border-box"&&(c.each(a,function(x,A){tb+=parseFloat(e.css(A))||0}),c.each(b,function(x,A){jd+=parseFloat(e.css(A))||0}));e.remove();var l=c("<div class='slick-row' />").appendTo(La);e=c("<div class='slick-cell' id='' style='visibility:hidden'>-</div>").appendTo(l);xc=yc=0;e.css("box-sizing")!="border-box"&&e.css("-moz-box-sizing")!="border-box"&&e.css("-webkit-box-sizing")!="border-box"&&(c.each(a,function(x,A){xc+=
parseFloat(e.css(A))||0}),c.each(b,function(x,A){yc+=parseFloat(e.css(A))||0}));l.remove();ob=Math.max(tb,xc)}function N(){ub=c("<style type='text/css' rel='stylesheet' />").appendTo(c("head"));var a=g.rowHeight-yc;a=["."+Qa+" .slick-header-column { left: 1000px; }","."+Qa+" .slick-top-panel { height:"+g.topPanelHeight+"px; }","."+Qa+" .grid-inner-top-panel { height:"+g.innerTopPanelHeight+"px; }","."+Qa+" .slick-headerrow-columns { height:"+g.headerRowHeight+"px; }","."+Qa+" .slick-cell { height:"+
a+"px; text-align:center; vertical-align: middle; }","."+Qa+" .slick-row { height:"+g.rowHeight+"px; line-height:"+a+"px; }"];for(var b=0;b<n.length;b++)a.push("."+Qa+" .l"+b+" { }"),a.push("."+Qa+" .r"+b+" { }");ub[0].styleSheet?ub[0].styleSheet.cssText=a.join(" "):ub[0].appendChild(document.createTextNode(a.join(" ")))}function B(a,b,e){e=e||new Slick.EventData;b=b||{};b.grid=T;return a.notify(b,e,T)}function W(){return g.editorLock}function Ea(){var a,b=[],e=0,l=0,x,A=lb?Oa-f.width:Oa;for(a=0;a<
n.length;a++){var H=n[a];b.push(H.width);l+=H.width;H.resizable&&(e+=H.width-Math.max(H.minWidth,ob))}for(x=l;l>A&&e;){var Z=(l-A)/e;for(a=0;a<n.length&&l>A;a++){H=n[a];var ca=b[a];if(!(!H.resizable||ca<=H.minWidth||ca<=ob)){H=Math.max(H.minWidth,ob);var X=Math.floor(Z*(ca-H))||1;X=Math.min(X,ca-H);l-=X;e-=X;b[a]-=X}}if(x<=l)break;x=l}for(x=l;l<A;){e=A/l;for(a=0;a<n.length&&l<A;a++)H=n[a],Z=b[a],H=!H.resizable||H.maxWidth<=Z?0:Math.min(Math.floor(e*Z)-Z,H.maxWidth-Z||1E6)||1,l+=H,b[a]+=H;if(x>=l)break;
x=l}l=!1;for(a=0;a<n.length;a++)n[a].rerenderOnResize&&n[a].width!=b[a]&&(l=!0),n[a].width=b[a];Ba();J(!0);l&&(Da(),C())}function Ba(){if(eb){for(var a,b=0,e=Ca.children(),l=e.length;b<l;b++)a=c(e[b]),a.width()!==n[b].width-tb&&a.width(n[b].width-tb);Pa()}}function D(){for(var a,b,e=0,l,x=0;x<n.length;x++){l=n[x].width;var A;b=x;if(!vb){var H=document.styleSheets;for(a=0;a<H.length;a++)if((H[a].ownerNode||H[a].owningElement)==ub[0]){vb=H[a];break}if(!vb)throw Error("Cannot find stylesheet.");zc=[];
Ac=[];H=vb.cssRules||vb.rules;for(a=0;a<H.length;a++){var Z=H[a].selectorText;if(A=/\.l\d+/.exec(Z))A=parseInt(A[0].substr(2,A[0].length-2),10),zc[A]=H[a];else if(A=/\.r\d+/.exec(Z))A=parseInt(A[0].substr(2,A[0].length-2),10),Ac[A]=H[a]}}a=zc[b];b=Ac[b];a.style.left=e+"px";b.style.right=hb-e-l+"px";e+=n[x].width}}function xa(a){Ra=a;var b=Ca.children();b.removeClass("slick-header-column-sorted").find(".slick-sort-indicator").removeClass("slick-sort-indicator-asc slick-sort-indicator-desc");c.each(Ra,
function(e,l){l.sortAsc==null&&(l.sortAsc=!0);e=Sa[l.columnId];e!=null&&b.eq(e).addClass("slick-header-column-sorted").find(".slick-sort-indicator").addClass(l.sortAsc?"slick-sort-indicator-asc":"slick-sort-indicator-desc")})}function ra(a,b){Bc=[];for(var e={},l=0;l<b.length;l++)for(var x=b[l].fromRow;x<=b[l].toRow;x++){e[x]||(Bc.push(x),e[x]={});for(var A=b[l].fromCell;A<=b[l].toCell;A++)kd(x,A)&&(e[x][n[A].id]=g.selectedCellCssClass)}y(g.selectedCellCssClass,e);B(T.onSelectedRowsChanged,{rows:ac()},
a)}function Pa(){Db=[];Eb=[];for(var a=0,b=0,e=n.length;b<e;b++)Db[b]=a,Eb[b]=a+n[b].width,a+=n[b].width}function Va(a){n=a;Sa={};for(a=0;a<n.length;a++){var b=n[a]=c.extend({},Cc,n[a]);Sa[b.id]=a;b.minWidth&&b.width<b.minWidth&&(b.width=b.minWidth);b.maxWidth&&b.width>b.maxWidth&&(b.width=b.maxWidth)}Pa();eb&&(Da(),qa(),ub.remove(),vb=null,N(),ua(),D(),h())}function ya(){return q.getLength?q.getLength():q.length}function Ta(){return ya()+(g.enableAddRow?1:0)}function za(a){return q.getItem?q.getItem(a):
q[a]}function Wa(a){return Math.floor((a+Ja)/g.rowHeight)}function L(a){a=Math.max(a,0);a=Math.min(a,bb-Fa+(wc?f.height:0));var b=Ja;Fb=Math.min(Gb-1,Math.floor(a/Hb));Ja=Math.round(Fb*bc);a-=Ja;if(Ja!=b){var e=S(a);Xa(e);for(var l in ka)ka[l].m.style.top=g.rowHeight*l-Ja+"px"}Ib!=a&&(wb=Ib+b<a+Ja?1:-1,Ha[0].scrollTop=cc=Ga=Ib=a,B(T.onViewportChanged,{}))}function U(a,b){var e=(a=q.getItemMetadata&&q.getItemMetadata(a))&&a.j&&(a.j[b.id]||a.j[Sa[b.id]]);return e&&e.formatter||a&&a.formatter||b.formatter||
g.formatterFactory&&g.formatterFactory.Rb(b)||g.defaultFormatter}function ja(a,b){var e=n[b];return(a=(a=q.getItemMetadata&&q.getItemMetadata(a))&&a.j)&&a[e.id]&&a[e.id].editor!==void 0?a[e.id].editor:a&&a[b]&&a[b].editor!==void 0?a[b].editor:e.editor||g.editorFactory&&g.editorFactory.Qb(e)}function ia(a,b){return g.dataItemColumnValueExtractor?g.dataItemColumnValueExtractor(a,b):a[b.field]}function Aa(a,b,e,l,x){var A=n[e],H="slick-cell l"+e+" r"+Math.min(n.length-1,e+l-1)+(A.cssClass?" "+A.cssClass:
"");b===da&&e===sa&&(H+=" active");for(var Z in Ya)Ya[Z][b]&&Ya[Z][b][A.id]&&(H+=" "+Ya[Z][b][A.id]);a.push("<div class='"+H+"'>");x&&(H=ia(x,A),a.push(U(b,A)(b,e,H,A,x)));a.push("</div>");ka[b].N.push(e);ka[b].Z[e]=l}function Xa(a){for(var b in ka)(b=parseInt(b,10))!==da&&(b<a.top||b>a.bottom)&&Ka(b)}function Da(){ha&&ib();Pb();for(var a in ka)Ka(a)}function Ka(a){var b=ka[a];b&&(dc==b.m?(b.m.style.display="none",Qb=dc):La[0].removeChild(b.m),delete ka[a],delete pb[a],Dc--,ld++)}function wa(a){var b;
if(a&&a.length){var e=wb=0;for(b=a.length;e<b;e++)ha&&da===a[e]&&ib(),Pb(),ka[a[e]]&&Ka(a[e])}}function mb(a){wa([a])}function fa(a){var b=ka[a];if(b){z(a);var e=za(a),l;for(l in b.i)if(b.i.hasOwnProperty(l)){l|=0;var x=n[l],A=b.i[l];a===da&&l===sa&&ha?ha.Na(e):A.innerHTML=e?U(a,x)(a,l,ia(e,x),x,e):""}v(a)}}function ua(){eb&&(Fa=g.autoHeight?g.rowHeight*Ta():parseFloat(c.css(ta[0],"height",!0))-parseFloat(c.css(ta[0],"paddingTop",!0))-parseFloat(c.css(ta[0],"paddingBottom",!0))-parseFloat(c.css(Bb[0],
"height"))-Q(Bb)-(g.showTopPanel?g.topPanelHeight+Q(Rb):0)-(g.showHeaderRow?g.headerRowHeight+Q(fb):0),ec=Math.ceil(Fa/g.rowHeight),Oa=parseFloat(c.css(ta[0],"width",!0)),g.autoHeight||Ha.height(Fa),g.forceFitColumns&&Ea(),aa(),h(),Sb=-1,C())}function aa(){if(eb){var a=Ta(),b=a+(g.leaveSpaceForNewRows?ec-1:0),e=lb,l=g.showInnerTopPanel?g.innerTopPanelHeight+Q(Jb):0,x=b*g.rowHeight+l,A=G();lb=!g.autoHeight&&x>Fa;!lb&&A>Oa&&x>Fa-f.height&&(lb=!0);ib();--a;for(var H in ka)H>=a&&Ka(H);oa&&da>a&&Pb();
H=cb;x>Fa-f.height?(cb=g.rowHeight*b,bb=x):cb=bb=Fa-f.height-l;bb<k?(Hb=bb,Gb=1,bc=0):(cb=k,Hb=cb/100,Gb=Math.floor(bb/Hb),bc=(bb-cb)/(Gb-1));cb!==H&&(La.css("height",cb),Ga=Ha[0].scrollTop);b=Ga+Ja<=bb-Fa;bb==0||Ga==0?Fb=Ja=0:b?L(Ga+Ja):L(bb-Fa);cb!=H&&g.autoHeight&&ua();g.forceFitColumns&&e!=lb&&Ea();J(!1)}}function S(a,b){a==null&&(a=Ga);b==null&&(b=Ua);return{top:Wa(a),bottom:Wa(a+Fa)+1,A:b,C:b+Oa}}function t(a,b){a=S(a,b);b=Math.round(Fa/g.rowHeight);wb==-1?(a.top-=b,a.bottom+=3):wb==1?(a.top-=
3,a.bottom+=b):(a.top-=3,a.bottom+=3);a.top=Math.max(0,a.top);a.bottom=Math.min(Ta()-1,a.bottom);a.A-=Oa;a.C+=Oa;a.A=Math.max(0,a.A);a.C=Math.min(hb,a.C);return a}function z(a){if((a=ka[a])&&a.N.length)for(var b=a.m.lastChild;a.N.length;){var e=a.N.pop();a.i[e]=b;b=b.previousSibling}}function m(){g.enableAsyncPostRender&&(clearTimeout(Ec),Ec=setTimeout(p,g.asyncPostRenderDelay))}function v(a){delete pb[a];Tb=Math.min(Tb,a);Ub=Math.max(Ub,a);m()}function C(){if(eb&&!Fc){var a=S(),b=t();Xa(b);if(Sb!=
Ua){for(var e,l=[],x=[],A,H,Z=b.top,ca=b.bottom;Z<=ca;Z++)if(e=ka[Z]){z(Z);var X=void 0;var pa=b;A=Z;var na=ka[A],ea=[];for(X in na.i)na.i.hasOwnProperty(X)&&(X|=0,H=na.Z[X],(Db[X]>pa.C||Eb[Math.min(n.length-1,X+H-1)]<pa.A)&&(A!=da||X!=sa)&&ea.push(X));for(;(X=ea.pop())!=null;)na.m.removeChild(na.i[X]),delete na.Z[X],delete na.i[X],pb[A]&&delete pb[A][X];A=0;na=(na=q.getItemMetadata&&q.getItemMetadata(Z))&&na.j;ea=za(Z);X=0;for(pa=n.length;X<pa&&!(Db[X]>b.C);X++)(H=e.Z[X])==null&&(H=1,na&&(H=(H=na[n[X].id]||
na[X])&&H.Ha||1,H==="*"&&(H=pa-X)),Eb[Math.min(pa-1,X+H-1)]>b.A&&(Aa(l,Z,X,H,ea),A++)),X+=H>1?H-1:0;A&&x.push(Z)}if(l.length)for(Z=document.createElement("div"),Z.innerHTML=l.join("");(e=x.pop())!=null;)for(e=ka[e];(ca=e.N.pop())!=null;)l=Z.lastChild,e.m.appendChild(l),e.i[ca]=l}x=La[0];e=[];l=[];Z=!1;na=ya();ca=b.top;for(A=b.bottom;ca<=A;ca++)if(!ka[ca]){Dc++;l.push(ca);ka[ca]={m:null,Z:[],i:[],N:[]};ea=e;X=ca;pa=b;var Na=na;H=za(X);var Ma="slick-row"+(X<Na&&!H?" loading":"")+(X===da?" active":"")+
(X%2==1?" odd":" even");H||(Ma+=" "+g.addNewRowCssClass);(Na=q.getItemMetadata&&q.getItemMetadata(X))&&Na.lb&&(Ma+=" "+Na.lb);ea.push("<div class='ui-widget-content "+Ma+"' style='top:"+(g.rowHeight*X-Ja)+"px'>");Ma=0;for(var Ob=n.length;Ma<Ob;Ma++){var Gc=n[Ma];var xb=1;Na&&Na.j&&(xb=(Gc=Na.j[Gc.id]||Na.j[Ma])&&Gc.Ha||1,xb==="*"&&(xb=Ob-Ma));if(Eb[Math.min(Ob-1,Ma+xb-1)]>pa.A){if(Db[Ma]>pa.C)break;Aa(ea,X,Ma,xb,H)}xb>1&&(Ma+=xb-1)}ea.push("</div>");oa&&da===ca&&(Z=!0);md++}if(l.length){b=document.createElement("div");
b.innerHTML=e.join("");ca=0;for(A=l.length;ca<A;ca++)ka[l[ca]].m=x.appendChild(b.firstChild);Z&&(oa=Za(da,sa))}Tb=a.top;Ub=Math.min(Ta()-1,a.bottom);m();cc=Ga;Sb=Ua;fc=null}}function d(){var a=fb[0].scrollLeft;a!=Ha[0].scrollLeft&&(Ha[0].scrollLeft=a)}function h(){Ga=Ha[0].scrollTop;Ua=Ha[0].scrollLeft;var a=Math.abs(Ga-Ib),b=Math.abs(Ua-nd);b&&(nd=Ua,Bb[0].scrollLeft=Ua,Rb[0].scrollLeft=Ua,fb[0].scrollLeft=Ua);if(a)if(wb=Ib<Ga?1:-1,Ib=Ga,a<Fa)L(Ga+Ja);else{var e=Ja;Fb=cb==Fa?0:Math.min(Gb-1,Math.floor((bb-
Fa)/(cb-Fa)*Ga*(1/Hb)));Ja=Math.round(Fb*bc);e!=Ja&&Da()}if(b||a)if(fc&&clearTimeout(fc),Math.abs(cc-Ga)>20||Math.abs(Sb-Ua)>20)g.forceSyncScrolling||Math.abs(cc-Ga)<Fa&&Math.abs(Sb-Ua)<Oa?C():fc=setTimeout(C,50),B(T.onViewportChanged,{});B(T.onScroll,{scrollLeft:Ua,scrollTop:Ga})}function p(){for(var a=ya();Tb<=Ub;){var b=wb>=0?Tb++:Ub--,e=ka[b];if(e&&!(b>=a)){pb[b]||(pb[b]={});z(b);for(var l in e.i)if(e.i.hasOwnProperty(l)&&(l|=0,a=n[l],a.jb&&!pb[b][l])){var x=e.i[l];x&&a.jb(x,b,za(b),a);pb[b][l]=
!0}Ec=setTimeout(p,g.asyncPostRenderDelay);break}}}function I(a,b){var e,l,x;for(x in ka){var A=b&&b[x];var H=a&&a[x];if(A)for(l in A)H&&A[l]==H[l]||(e=Za(x,Sa[l]))&&c(e).removeClass(A[l]);if(H)for(l in H)A&&A[l]==H[l]||(e=Za(x,Sa[l]))&&c(e).addClass(H[l])}}function y(a,b){var e=Ya[a];Ya[a]=b;I(b,e);B(T.onCellCssStylesChanged,{key:a,hash:b})}function F(a){a=c(a.target).closest(".slick-row")[0];a!=dc&&(Qb&&Qb!=a&&(La[0].removeChild(Qb),Qb=null),dc=a)}function P(a,b){var e=Vb(a);if(!e||!Hc(e.row,e.cell))return!1;
b=B(T.onDragInit,b,a);return a.isImmediatePropagationStopped()?b:!1}function R(a,b){var e=Vb(a);if(!e||!Hc(e.row,e.cell))return!1;b=B(T.onDragStart,b,a);return a.isImmediatePropagationStopped()?b:!1}function la(a,b){return B(T.onDrag,b,a)}function ma(a,b){B(T.onDragEnd,b,a)}function gb(a){B(T.onKeyDown,{row:da,cell:sa},a);var b=a.isImmediatePropagationStopped();if(!b)if(a.shiftKey||a.altKey||a.ctrlKey)a.which!=9||!a.shiftKey||a.ctrlKey||a.altKey||((e=ac())&&e.length?Wb(e[0],!1):b=wd());else if(a.which==
27){if(!W().isActive())return;od()}else if(a.which==34)pd(),b=!0;else if(a.which==33)qd(),b=!0;else if(a.which==37)b=rd();else if(a.which==39)b=sd();else if(a.which==38)b=td();else if(a.which==40)b=gc();else if(a.which==9){var e=ac();e&&e.length?Wb(e[0],!1):b=ud()}else if(a.which==13){if(g.editable)ha?da===ya()?gc():vd():W().commitCurrentEdit()&&hc();else if(b=Ic())e=new Slick.EventData,e.target=oa,B(T.onFocusTrigger,{row:b.row,cell:b.cell},e);b=!0}if(b){a.stopPropagation();a.preventDefault();try{a.originalEvent.keyCode=
0}catch(l){}}}function xe(a){ha||(a.target!=document.activeElement||c(a.target).hasClass("slick-cell"))&&yb();var b=Vb(a);!b||ha!==null&&da==b.row&&sa==b.cell||(B(T.onClick,{row:b.row,cell:b.cell},a),a.isImmediatePropagationStopped()||sa==b.cell&&da==b.row||!jb(b.row,b.cell)||W().isActive()&&!W().commitCurrentEdit()||(Wb(b.row,!1),zb(Za(b.row,b.cell))))}function ze(a){var b=c(a.target).closest(".slick-cell",La);b.length===0||oa===b[0]&&ha!==null||B(T.onContextMenu,{},a)}function ye(a){var b=Vb(a);
!b||ha!==null&&da==b.row&&sa==b.cell||(B(T.onDblClick,{row:b.row,cell:b.cell},a),a.isImmediatePropagationStopped()||g.editable&&xd(b.row,b.cell,!0))}function ve(a){B(T.onHeaderMouseEnter,{column:c(this).data("column")},a)}function we(a){B(T.onHeaderMouseLeave,{column:c(this).data("column")},a)}function te(a){var b=c(a.target).closest(".slick-header-column",".slick-header-columns");b=b&&b.data("column");B(T.onHeaderContextMenu,{column:b},a)}function ue(a){var b=c(a.target).closest(".slick-header-column",
".slick-header-columns");(b=b&&b.data("column"))&&B(T.onHeaderClick,{column:b},a)}function Ae(a){B(T.onMouseEnter,{},a)}function Be(a){B(T.onMouseLeave,{},a)}function Hc(a,b){return!(a<0||a>=ya()||b<0||b>=n.length)}function Jc(a){var b=/l\d+/.exec(a.className);if(!b)throw"getCellFromNode: cannot get cell - "+a.className;return parseInt(b[0].substr(1,b[0].length-1),10)}function Kc(a){for(var b in ka)if(ka[b].m===a)return b|0;return null}function Vb(a){var b=c(a.target).closest(".slick-cell",La);if(!b.length)return null;
a=Kc(b[0].parentNode);b=Jc(b[0]);return a==null||b==null?null:{row:a,cell:b}}function Pb(){zb(null,!1)}function yb(){yd==-1?Zb[0].focus():vc[0].focus()}function ic(a,b,e){Wb(a,e);e=Kb(a,b);a=Db[b];b=Eb[b+(e>1?e-1:0)];e=Ua+Oa;a<Ua?(Ha.scrollLeft(a),h(),C()):b>e&&(Ha.scrollLeft(Math.min(a,b-Ha[0].clientWidth)),h(),C())}function zb(a,b){oa!==null&&(ib(),c(oa).removeClass("active"),ka[da]&&c(ka[da].m).removeClass("active"));var e=oa!==a;oa=a;oa!=null?(da=Kc(oa.parentNode),sa=Lb=Jc(oa),b==null&&(b=da==
ya()||g.autoEdit),c(oa).addClass("active"),c(ka[da].m).addClass("active"),g.editable&&b&&zd(da,sa)&&(clearTimeout(Lc),g.asyncEditorLoading?Lc=setTimeout(function(){hc()},g.asyncEditorLoadDelay):hc())):da=sa=null;e&&B(T.onActiveCellChanged,Ic())}function zd(a,b){var e=ya();return a<e&&!za(a)||n[b].Kb&&a>=e||!ja(a,b)?!1:!0}function ib(){if(ha){B(T.vb,{editor:ha});ha.destroy();ha=null;if(oa){var a=za(da);c(oa).removeClass("editable invalid");if(a){var b=n[sa],e=U(da,b);oa.innerHTML=e(da,sa,ia(a,b),b,
a);v(da)}}if(navigator.userAgent.toLowerCase().match(/msie/))if(document.selection&&document.selection.empty)try{document.selection.empty()}catch(l){}else window.getSelection&&(a=window.getSelection())&&a.removeAllRanges&&a.removeAllRanges();W().deactivate(jc)}}function hc(a){if(oa){if(!g.editable)throw"Grid : makeActiveCellEditable : should never get called when options.editable is false";clearTimeout(Lc);if(zd(da,sa)){var b=n[sa],e=za(da);B(T.onBeforeEditCell,{row:da,cell:sa,item:e,column:b})===
!1?yb():(W().activate(jc),c(oa).addClass("editable"),a||(oa.innerHTML=""),ha=new (a||ja(da,sa))({grid:T,Vb:kc(ta[0]),position:kc(oa),Nb:oa,column:b,item:e||{},Mb:vd,Jb:od}),e&&ha.Na(e),Ad=ha.Ra(),ha.position&&id())}}}function vd(){W().commitCurrentEdit()&&(yb(),g.autoEdit&&gc())}function od(){W().cancelCurrentEdit()&&yb()}function kc(a){var b={top:a.offsetTop,left:a.offsetLeft,bottom:0,right:0,width:c(a).outerWidth(),height:c(a).outerHeight(),visible:!0};b.bottom=b.top+b.height;b.right=b.left+b.width;
for(var e=a.offsetParent;(a=a.parentNode)!=document.body;)b.visible&&a.scrollHeight!=a.offsetHeight&&c(a).css("overflowY")!="visible"&&(b.visible=b.bottom>a.scrollTop&&b.top<a.scrollTop+a.clientHeight),b.visible&&a.scrollWidth!=a.offsetWidth&&c(a).css("overflowX")!="visible"&&(b.visible=b.right>a.scrollLeft&&b.left<a.scrollLeft+a.clientWidth),b.left-=a.scrollLeft,b.top-=a.scrollTop,a===e&&(b.left+=a.offsetLeft,b.top+=a.offsetTop,e=a.offsetParent),b.bottom=b.top+b.height,b.right=b.left+b.width;return b}
function Bd(){return kc(oa)}function id(){if(oa&&(B(T.onActiveCellPositionChanged,{}),ha)){var a=Bd();ha.show&&ha.hide&&(a.visible?ha.show():ha.hide());ha.position&&ha.position(a)}}function Ic(){return oa?{row:da,cell:sa}:null}function Wb(a,b){var e=a*g.rowHeight,l=(a+1)*g.rowHeight-Fa+(wc?f.height:0);(a+1)*g.rowHeight>Ga+Fa+Ja?(L(b?e:l),C()):a*g.rowHeight<Ga+Ja&&(L(b?l:e),C())}function Cd(a){a*=ec;L((Wa(Ga)+a)*g.rowHeight);C();if(g.enableCellNavigation&&da!=null){a=da+a;var b=Ta();a>=b&&(a=b-1);
a<0&&(a=0);b=0;for(var e=null,l=Lb;b<=Lb;)jb(a,b)&&(e=b),b+=Kb(a,b);e!==null?(zb(Za(a,e)),Lb=l):Pb()}}function pd(){Cd(1)}function qd(){Cd(-1)}function Kb(a,b){a=q.getItemMetadata&&q.getItemMetadata(a);if(!a||!a.j)return 1;a=(a=a.j[n[b].id]||a.j[b])&&a.Ha;return a=a==="*"?n.length-b:a||1}function Dd(a,b){if(b>=n.length)return null;do b+=Kb(a,b);while(b<n.length&&!jb(a,b));return b<n.length?{row:a,cell:b,B:b}:null}function Ce(a,b){if(b<=0)return null;var e;a:{for(e=0;e<n.length;){if(jb(a,e))break a;
e+=Kb(a,e)}e=null}if(e===null||e>=b)return null;for(a={row:a,cell:e,B:e};;){e=Dd(a.row,a.cell,a.B);if(!e)return null;if(e.cell>=b)return a;a=e}}function De(a,b,e){for(var l,x=Ta();;){if(++a>=x)return null;for(l=b=0;b<=e;)l=b,b+=Kb(a,b);if(jb(a,l))return{row:a,cell:l,B:e}}}function Ee(a,b,e){for(var l;;){if(--a<0)return null;for(l=b=0;b<=e;)l=b,b+=Kb(a,b);if(jb(a,l))return{row:a,cell:l,B:e}}}function Fe(a,b){return a==null&&b==null&&(a=b=0,jb(a,b))?{row:a,cell:b,B:b}:null}function Ge(a,b){return a==
null&&b==null&&(a=Ta()-1,b=n.length-1,jb(a,b))?{row:a,cell:b,B:b}:null}function sd(){return Mb("right")}function rd(){return Mb("left")}function gc(){return Mb("down")}function td(){return Mb("up")}function ud(){return Mb("next")}function wd(){return Mb("prev")}function Mb(a){if(!g.enableCellNavigation||!oa&&a!="prev"&&a!="next")return!1;if(!W().commitCurrentEdit())return!0;yb();yd={up:-1,down:1,left:-1,right:1,prev:-1,next:1}[a];if(a=(0,{up:Ee,down:De,left:Ce,right:Dd,prev:Ge,next:Fe}[a])(da,sa,
Lb)){var b=a.row==ya();ic(a.row,a.cell,!b);zb(Za(a.row,a.cell));Lb=a.B;return!0}zb(Za(da,sa));return!1}function Za(a,b){return ka[a]?(z(a),ka[a].i[b]):null}function jb(a,b){return!g.enableCellNavigation||a>=Ta()||a<0||b>=n.length||b<0||n[b]._noactive?!1:(a=q.getItemMetadata&&q.getItemMetadata(a))&&typeof a.focusable==="boolean"?a.focusable:(a=a&&a.j)&&a[n[b].id]&&typeof a[n[b].id].focusable==="boolean"?a[n[b].id].focusable:a&&a[b]&&typeof a[b].focusable==="boolean"?a[b].focusable:n[b].focusable}function kd(a,
b){return a>=ya()||a<0||b>=n.length||b<0?!1:(a=q.getItemMetadata&&q.getItemMetadata(a))&&typeof a.selectable==="boolean"?a.selectable:(a=a&&a.j&&(a.j[n[b].id]||a.j[b]))&&typeof a.selectable==="boolean"?a.selectable:n[b].selectable}function xd(a,b,e){eb&&jb(a,b)&&W().commitCurrentEdit()&&(ic(a,b,!1),b=Za(a,b),zb(b,e||a===ya()||g.autoEdit),ha||yb())}function He(){var a=za(da),b=n[sa];if(ha){if(ha.Yb()){var e=ha.validate();if(e.valid)return da<ya()?(e={row:da,cell:sa,editor:ha,Ab:ha.Ra(),zb:Ad,pb:function(){this.editor.Fa(a,
this.Ab);fa(this.row);B(T.onCellChange,{row:da,cell:sa,item:a})},ec:function(){this.editor.Fa(a,this.zb);fa(this.row);B(T.onCellChange,{row:da,cell:sa,item:a})}},g.nb?(ib(),g.nb(a,b,e)):(e.pb(),ib())):(e={},ha.Fa(e,ha.Ra()),ib(),B(T.onAddNewRow,{item:e,column:b})),!W().isActive();c(oa).removeClass("invalid");c(oa).width();c(oa).addClass("invalid");B(T.yb,{editor:ha,Lb:oa,fc:e,row:da,cell:sa,column:b});ha.focus();return!1}ib()}return!0}function Ie(){ib();return!0}function ac(){if(!db)throw"Selection model is not set";
return Bc}var Je={explicitInitialization:!1,rowHeight:25,defaultColumnWidth:80,enableAddRow:!1,leaveSpaceForNewRows:!1,editable:!1,autoEdit:!0,enableCellNavigation:!0,enableColumnReorder:!0,asyncEditorLoading:!1,asyncEditorLoadDelay:100,forceFitColumns:!1,enableAsyncPostRender:!1,asyncPostRenderDelay:50,autoHeight:!1,editorLock:Slick.GlobalEditorLock,showHeaderRow:!1,headerRowHeight:25,showTopPanel:!1,topPanelHeight:25,showInnerTopPanel:!1,innerTopPanelHeight:25,formatterFactory:null,editorFactory:null,
cellFlashingCssClass:"flashing",selectedCellCssClass:"selected",multiSelect:!0,enableTextSelectionOnCells:!1,dataItemColumnValueExtractor:null,fullWidthRows:!1,multiColumnSort:!1,defaultFormatter:function(a,b,e){return e==null?"":(e+"").replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;")},forceSyncScrolling:!1,addNewRowCssClass:"new-row"},Cc={name:"",resizable:!0,sortable:!1,minWidth:30,rerenderOnResize:!1,headerCssClass:null,defaultSortAsc:!0,focusable:!0,selectable:!0},bb,cb,Hb,Gb,bc,
Fb=0,Ja=0,wb=1,eb=!1,ta,Qa="slickgrid_"+Math.round(1E6*Math.random()),T=this,Zb,vc,Bb,Ca,sb,fb,hd,Rb,Ha,Jb,La,ub,Cb,vb,zc,Ac,Fa,Oa,hb,wc,lb,tb=0,jd=0,xc=0,yc=0,ob,yd=1,Lb,da,sa,oa=null,ha=null,Ad,jc,ka={},Dc=0,ec,Ib=0,Ga=0,cc=0,Sb=0,nd=0,Ua=0,db,Bc=[],nb=[],Ya={},Sa={},Ra=[],Db=[],Eb=[],Lc=null,fc=null,Ec=null,pb={},Ub=null,Tb=null,md=0,ld=0,dc,Qb,Fc=!1;this.debug=function(){var a="\ncounter_rows_rendered:  "+md;a+="\ncounter_rows_removed:  "+ld;a+="\nrenderedRows:  "+Dc;a+="\nnumVisibleRows:  "+
ec;a+="\nmaxSupportedCssHeight:  "+k;a+="\nn(umber of pages):  "+Gb;a+="\n(current) page:  "+Fb;a+="\npage height (ph):  "+Hb;a+="\nvScrollDir:  "+wb;alert(a)};c.extend(this,{slickGridVersion:"2.1",onScroll:new Slick.Event,onSort:new Slick.Event,onHeaderMouseEnter:new Slick.Event,onHeaderMouseLeave:new Slick.Event,onHeaderContextMenu:new Slick.Event,onHeaderClick:new Slick.Event,Pa:new Slick.Event,Oa:new Slick.Event,xb:new Slick.Event,wb:new Slick.Event,onMouseEnter:new Slick.Event,onMouseLeave:new Slick.Event,
onClick:new Slick.Event,onFocusTrigger:new Slick.Event,onDblClick:new Slick.Event,onContextMenu:new Slick.Event,onKeyDown:new Slick.Event,onAddNewRow:new Slick.Event,yb:new Slick.Event,onViewportChanged:new Slick.Event,onColumnsReordered:new Slick.Event,onColumnsResized:new Slick.Event,onCellChange:new Slick.Event,onBeforeEditCell:new Slick.Event,vb:new Slick.Event,onBeforeDestroy:new Slick.Event,onActiveCellChanged:new Slick.Event,onActiveCellPositionChanged:new Slick.Event,onDragInit:new Slick.Event,
onDragStart:new Slick.Event,onDrag:new Slick.Event,onDragEnd:new Slick.Event,onSelectedRowsChanged:new Slick.Event,onCellCssStylesChanged:new Slick.Event,registerPlugin:function(a){nb.unshift(a);a.init(T)},unregisterPlugin:r,getColumns:function(){return n},setColumns:Va,getColumnIndex:function(a){return Sa[a]},updateColumnHeader:function(a,b,e){if(eb&&(a=Sa[a],a!=null)){var l=n[a],x=Ca.children().eq(a);x&&(b!==void 0&&(n[a].name=b),e!==void 0&&(n[a].toolTip=e),B(T.Oa,{node:x[0],column:l}),x.attr("title",
e||"").children().eq(0).html(b),B(T.Pa,{node:x[0],column:l}))}},setSortColumn:function(a,b){xa([{columnId:a,sortAsc:b}])},setSortColumns:xa,getSortColumns:function(){return Ra},autosizeColumns:Ea,getOptions:function(){return g},setOptions:function(a){W().commitCurrentEdit()&&(ib(),g.enableAddRow!==a.enableAddRow&&mb(ya()),g=c.extend(g,a),g.autoHeight&&(g.leaveSpaceForNewRows=!1),Ha.css("overflow-y",g.autoHeight?"hidden":"auto"),C())},getData:function(){return q},getDataLength:ya,getDataItem:za,setData:function(a,
b){q=a;Da();aa();b&&L(0)},getSelectionModel:function(){return db},setSelectionModel:function(a){db&&(db.onSelectedRangesChanged.unsubscribe(ra),db.destroy&&db.destroy());if(db=a)db.init(T),db.onSelectedRangesChanged.subscribe(ra)},getSelectedRows:ac,setSelectedRows:function(a){if(!db)throw"Selection model is not set";for(var b=db,e=b.setSelectedRanges,l=[],x=n.length-1,A=0;A<a.length;A++)l.push(new Slick.Range(a[A],0,a[A],x));e.call(b,l)},getContainerNode:function(){return ta.get(0)},render:C,invalidate:function(){aa();
Da();C()},invalidateRow:mb,invalidateRows:wa,invalidateAllRows:Da,updateCell:function(a,b){var e=Za(a,b);if(e){var l=n[b],x=za(a);ha&&da===a&&sa===b?ha.Na(x):(e.innerHTML=x?U(a,l)(a,b,ia(x,l),l,x):"",v(a))}},updateRow:fa,getViewport:S,getRenderedRange:t,resizeCanvas:ua,updateRowCount:aa,scrollRowIntoView:Wb,scrollRowToTop:function(a){L(a*g.rowHeight);C()},scrollCellIntoView:ic,getCanvasNode:function(){return La[0]},focus:yb,getCellFromPoint:function(a,b){b=Wa(b);for(var e=0,l=0,x=0;x<n.length&&l<
a;x++)l+=n[x].width,e++;e<0&&(e=0);return{row:b,cell:e-1}},getCellFromEvent:Vb,getActiveCell:Ic,setActiveCell:function(a,b){!eb||a>ya()||a<0||b>=n.length||b<0||!g.enableCellNavigation||(ic(a,b,!1),zb(Za(a,b),!1))},getActiveCellNode:function(){return oa},getActiveCellPosition:Bd,resetActiveCell:Pb,editActiveCell:hc,getCellEditor:function(){return ha},getCellNode:Za,getCellNodeBox:function(a,b){if(!Hc(a,b))return null;a=g.rowHeight*a-Ja;for(var e=a+g.rowHeight-1,l=0,x=0;x<b;x++)l+=n[x].width;return{top:a,
left:l,bottom:e,right:l+n[b].width}},canCellBeSelected:kd,canCellBeActive:jb,navigatePrev:wd,navigateNext:ud,navigateUp:td,navigateDown:gc,navigateLeft:rd,navigateRight:sd,navigatePageUp:qd,navigatePageDown:pd,gotoCell:xd,getInnerTopPanel:function(){return Jb[0]},setInnerTopPanelVisibility:function(a){g.showInnerTopPanel!=a&&((g.showInnerTopPanel=a)?Jb.slideDown("fast",ua):Jb.slideUp("fast",ua))},setHeaderRowVisibility:function(a){g.showHeaderRow!=a&&((g.showHeaderRow=a)?fb.slideDown("fast",ua):fb.slideUp("fast",
ua))},getHeaderRow:function(){return sb[0]},getHeaderRowColumn:function(a){a=Sa[a];return(a=sb.children().eq(a))&&a[0]},getGridPosition:function(){return kc(ta[0])},flashCell:function(a,b,e){function l(A){A&&setTimeout(function(){x.queue(function(){x.toggleClass(g.cellFlashingCssClass).dequeue();l(A-1)})},e)}e=e||100;if(ka[a]){var x=c(Za(a,b));l(4)}},addCellCssStyles:function(a,b){if(Ya[a])throw"addCellCssStyles: cell CSS hash with key '"+a+"' already exists.";Ya[a]=b;I(b,null);B(T.onCellCssStylesChanged,
{key:a,hash:b})},setCellCssStyles:y,removeCellCssStyles:function(a){Ya[a]&&(I(null,Ya[a]),delete Ya[a],B(T.onCellCssStylesChanged,{key:a,hash:null}))},getCellCssStyles:function(a){return Ya[a]},init:w,destroy:function(){W().cancelCurrentEdit();B(T.onBeforeDestroy,{});for(var a=nb.length;a--;)r(nb[a]);g.enableColumnReorder&&Ca.filter(":ui-sortable").sortable("destroy");Cb&&(Cb.unbind("scroll."+Qa),Cb=null);ta.unbind(".slickgrid");ub.remove();vb=null;La.unbind("draginit dragstart dragend drag");ta.empty().removeClass(Qa)},
getEditorLock:W,getEditController:function(){return jc},measureCellPaddingAndBorder:V,beginRender:function(){Fc=!0},endRender:function(a){Fc=!1;a!=0&&C()},onColumnResizerDblClick:new Slick.Event,enableColumnFit:function(){function a(e){var l=e.cloneNode(!0);l.style.cssText="position: absolute; right: auto;text-overflow: initial;white-space: nowrap; visibility: hidden;";e.parentNode.insertBefore(l,e);e=l.offsetWidth;l.parentNode.removeChild(l);return e}var b=document.createElement("canvas").getContext("2d");
T.onColumnResizerDblClick.subscribe(function(e,l){if((e=l.column)&&e._nofit!=1){l=Sa[e.id];var x=Ca.children()[l];x=x?a(x)+8:0;for(var A=0,H=S(),Z=H.top,ca=H.top;ca<H.bottom;++ca)if(ka[ca]){z(ca);var X=ka[ca].i[l];X=X?b.measureText(X.textContent||"").width:0;X>A&&(A=X,Z=ca)}l=ka[Z]?1+a(ka[Z].i[l]):0;l=Math.max(x,l);l>0&&l!=e.width&&(e.width=l,Ba(),J(!0),B(T.onColumnsResized,{}))}})},getRowNode:function(a){return ka[a]?ka[a].m:null},getCellNodeFromEvent:function(a){a=c(a.target).closest(".slick-cell",
La);if(!a.length)return null;var b=Kc(a[0].parentNode),e=Jc(a[0]);return b==null||e==null?null:{row:b,cell:e,$cell:a}}});(function(){ta=c(u);if(ta.length<1)throw Error("SlickGrid requires a valid container, "+u+" does not exist in the DOM.");var a;if(!(a=k)){a=1E6;for(var b=navigator.userAgent.toLowerCase().match(/firefox/)?6E6:1E9,e=c("<div style='display:none' />").appendTo(document.body);;){var l=a*2;e.css("height",l);if(l>b||e.height()!==l)break;else a=l}e.remove()}k=a;(a=f)||(a=c("<div style='position:absolute; top:-10000px; left:-10000px; width:100px; height:100px; overflow:scroll;'></div>").appendTo("body"),
b={width:a.width()-a[0].clientWidth,height:a.height()-a[0].clientHeight},a.remove(),a=b);f=a;g=c.extend({},Je,g);g.autoHeight&&(g.leaveSpaceForNewRows=!1);Cc.width=g.defaultColumnWidth;Sa={};for(a=0;a<n.length;a++)b=n[a]=c.extend({},Cc,n[a]),Sa[b.id]=a,b.minWidth&&b.width<b.minWidth&&(b.width=b.minWidth),b.maxWidth&&b.width>b.maxWidth&&(b.width=b.maxWidth);if(g.enableColumnReorder&&!c.fn.sortable)throw Error("SlickGrid's 'enableColumnReorder = true' option requires jquery-ui.sortable module to be loaded");
jc={commitCurrentEdit:He,cancelCurrentEdit:Ie};ta.empty().css("overflow","hidden").css("outline",0).addClass(Qa).addClass("ui-widget");/relative|absolute|fixed/.test(ta.css("position"))||ta.css("position","relative");Zb=c("<div tabIndex='0' hideFocus style='position:fixed;width:0;height:0;top:0;left:0;outline:0;'></div>").appendTo(ta);Bb=c("<div class='slick-header ui-state-default' style='overflow:hidden;position:relative;' />").appendTo(ta);Ca=c("<div class='slick-header-columns' style='left:-1000px' />").appendTo(Bb);
Ca.width(E());fb=c("<div class='slick-headerrow ui-state-default' style='overflow:hidden;position:relative;' />").appendTo(ta);sb=c("<div class='slick-headerrow-columns' />").appendTo(fb);hd=c("<div style='display:block;height:1px;position:absolute;top:0;left:0;'></div>").css("width",G()+f.width+"px").appendTo(fb);Rb=c("<div class='slick-top-panel-scroller ui-state-default' style='overflow:hidden;position:relative;' />").appendTo(ta);c("<div class='slick-top-panel' style='width:10000px' />").appendTo(Rb);
g.showTopPanel||Rb.hide();g.showHeaderRow||fb.hide();Ha=c("<div class='slick-viewport' style='width:100%;overflow:auto;outline:0;position:relative;;'>").appendTo(ta);Ha.css("overflow-y",g.autoHeight?"hidden":"auto");La=c("<div class='grid-canvas' />").appendTo(Ha);Jb=c("<div class='grid-inner-top-panel'/>").appendTo(Ha);g.showInnerTopPanel||Jb.hide();vc=Zb.clone().appendTo(ta);g.explicitInitialization||w()})()}}});var f,k})(jQuery);
(function(c){c.extend(!0,window,{Slick:{Data:{DataView:function(f){function k(){return!0}function u(d){for(var h=d||0,p=D.length;h<p;h++){d=D[h][Ba];if(d===void 0)throw"Each data element must implement a unique 'id' property";ra[d]=h}}function q(){return{pageSize:S,pageNum:t,totalRows:z,totalPages:S?Math.max(1,Math.ceil(z/S)):1}}function n(d,h){za=h;L=d;Wa=null;if(d){h===!1&&D.reverse();for(var p=0,I=D.length;p<I;++p)D[p].index=p;D.sort(d);h===!1&&D.reverse();ra={};u();W()}}function g(d,h){za=h;Wa=
d;L=null;var p=Object.prototype.toString;Object.prototype.toString=typeof d=="function"?d:function(){return this[d]};h===!1&&D.reverse();D.sort();Object.prototype.toString=p;h===!1&&D.reverse();ra={};u();W()}function w(d){za===!1&&d.reverse();d.sort(L);za===!1&&d.reverse();ra={};for(var h=0,p=0;h<d.length||p<D.length;++p)h<d.length&&(p==D.length||L(d[h],D[p])>0!=za)&&D.splice(p,0,d[h++]),ra[D[p].id]=p;W()}function r(d){f.groupItemMetadataProvider||(f.groupItemMetadataProvider=new Slick.Data.GroupItemMetadataProvider);
ua=[];aa=[];d=d||[];fa=d instanceof Array?d:[d];for(d=0;d<fa.length;d++){var h=fa[d]=c.extend(!0,{},mb,fa[d]);h.qb=typeof h.ba==="function";h.na=[];for(var p=h.G.length;p--;){var I=h.na,y=p,F=Ia(h.G[p].Y);F=new Function("_items","for (var "+F.H[0]+", _i=0, _il=_items.length; _i<_il; _i++) {"+F.H[0]+" = _items[_i]; "+F.body+"}");F.displayName=F.name="compiledAccumulatorLoop";I[y]=F}aa[d]={}}W()}function E(){if(!Pa){Pa={};for(var d=0,h=xa.length;d<h;d++)Pa[xa[d][Ba]]=d}}function G(d,h){if(d==null)for(d=
0;d<fa.length;d++)aa[d]={},fa[d].collapsed=h;else aa[d]={},fa[d].collapsed=h;W()}function J(d,h,p){aa[d][h]=fa[d].collapsed^p;W()}function ba(d,h){for(var p,I,y=[],F={},P,R=h?h.level+1:0,la=fa[R],ma=0,gb=la.Qa.length;ma<gb;ma++)I=la.Qa[ma],p=F[I],p||(p=new Slick.Group,p.value=I,p.level=R,p.P=(h?h.P+":|:":"")+I,y[y.length]=p,F[I]=p);ma=0;for(gb=d.length;ma<gb;ma++)P=d[ma],I=la.qb?la.ba(P):P[la.ba],p=F[I],p||(p=new Slick.Group,p.value=I,p.level=R,p.P=(h?h.P+":|:":"")+I,y[y.length]=p,F[I]=p),p.rows[p.count++]=
P;if(R<fa.length-1)for(ma=0;ma<y.length;ma++)p=y[ma],p.groups=ba(p.rows,p);y.sort(fa[R].Ia);return y}function Y(d){var h=d.group,p=fa[h.level],I=h.level==fa.length,y,F=p.G.length;if(!I&&p.Ea)for(y=h.groups.length;y--;)h.groups[y].da||Y(h.groups[y]);for(;F--;)y=p.G[F],y.init(),!I&&p.Ea?p.na[F].call(y,h.groups):p.na[F].call(y,h.rows),y.ga(d);d.da=!0}function qa(d,h){h=h||0;for(var p=fa[h],I=p.collapsed,y=aa[h],F=d.length,P;F--;)if(P=d[F],!P.collapsed||p.ma){P.groups&&qa(P.groups,h+1);if(p.G.length&&
(p.ib||P.rows.length||P.groups&&P.groups.length)){var R=P,la=fa[R.level],ma=new Slick.GroupTotals;ma.group=R;R.I=ma;la.tb||Y(ma)}P.collapsed=I^y[P.P];P.title=p.formatter?p.formatter(P):P.value}}function M(d,h){h=h||0;for(var p=fa[h],I=[],y,F=0,P,R=0,la=d.length;R<la;R++){P=d[R];I[F++]=P;if(!P.collapsed){y=P.groups?M(P.groups,h+1):P.rows;for(var ma=0,gb=y.length;ma<gb;ma++)I[F++]=y[ma]}P.I&&p.Ja&&(!P.collapsed||p.ma)&&(I[F++]=P.I)}return I}function Ia(d){d=d.toString().match(/^function[^(]*\(([^)]*)\)\s*{([\s\S]*)}$/);
return{H:d[1].split(","),body:d[2]}}function va(d,h){for(var p=[],I=0,y=0,F=d.length;y<F;y++)Va(d[y],h)&&(p[I++]=d[y]);return p}function Q(d,h,p){for(var I=[],y=0,F,P=0,R=d.length;P<R;P++)F=d[P],p[P]?I[y++]=F:Va(F,h)&&(I[y++]=F,p[P]=!0);return I}function V(d,h){for(var p=[],I=0,y,F,P,R=0,la=d.length;R<la;R++)y=d[R],F=y.M||(y.M={}),P=F[h],!(P||P==void 0&&(F[h]=Va(y,h)))||wa&&!k(y,wa)||(p[I++]=y);return p}function N(d,h,p){for(var I=[],y=0,F,P,R,la=0,ma=d.length;la<ma;la++)F=d[la],P=F.M||(F.M={}),R=
P[h],p[la]?I[y++]=F:!(R||R==void 0&&(P[h]=Va(F,h)))||wa&&!k(F,wa)||(I[y++]=F,p[la]=!0);return I}function B(d){Pa=null;if(U.Ma!=ja.Ma||U.La!=ja.La)Ka=[];if(Va){var h=f.inlineFilters?Xa:f.cacheFilters?V:va,p=f.inlineFilters?Da:f.cacheFilters?N:Q;U.Ma?Aa=h(Aa,ia):U.La?Aa=p(d,ia,Ka):U.Xb||(Aa=h(d,ia))}else Aa=S?d:d.concat();S?(Aa.length<t*S&&(t=Math.floor(Aa.length/S)),h=Aa.slice(S*t,S*t+S)):h=Aa;z=d=Aa.length;d=h;ua=[];fa.length&&(ua=ba(d),ua.length&&(qa(ua),d=M(ua)));h=xa;p=d;var I,y=[];var F=0;var P=
p.length;U&&U.sb&&(F=Math.max(0,Math.min(p.length,U.sb)));U&&U.rb&&(P=Math.min(p.length,Math.max(0,U.rb)));for(var R=F,la=h.length;R<P;R++)if(R>=la)y[y.length]=R;else{F=p[R];var ma=h[R];if(fa.length&&(I=F.Ba||ma.Ba)&&F.L!==ma.L||F.L&&!F.ob(ma)||I&&(F.X||ma.X)||F[Ba]!=ma[Ba]||ya&&ya[F[Ba]])y[y.length]=R}xa=d;return y}function W(){if(!Ta){var d=xa.length,h=z,p=B(D);S&&z<t*S&&(t=Math.max(0,Math.ceil(z/S)-1),p=B(D));ya=null;ja=U;U={};h!=z&&C.notify(q(),null,Ea);d!=xa.length&&m.notify({previous:d,current:xa.length,
diffRows:p},null,Ea);p.length>0&&v.notify({rows:p},null,Ea)}}var Ea=this,Ba="id",D=[],xa=[],ra={},Pa=null,Va=null,ya=null,Ta=!1,za=!0,Wa,L,U={},ja={},ia,Aa=[],Xa,Da,Ka=[],wa="",mb={ba:null,formatter:null,Ia:function(d,h){return d.value-h.value},Qa:[],G:[],ib:!1,ma:!1,Ea:!1,collapsed:!1,Ja:!0,tb:!1},fa=[],ua=[],aa=[],S=0,t=0,z=0,m=new Slick.Event,v=new Slick.Event,C=new Slick.Event;f=c.extend(!0,{},{groupItemMetadataProvider:null,inlineFilters:!1,cacheFilters:!1},f);c.extend(this,{beginUpdate:function(){Ta=
!0},endUpdate:function(){Ta=!1;W()},setPagingOptions:function(d){d.pageSize!=void 0&&(t=(S=d.pageSize)?Math.min(t,Math.max(0,Math.ceil(z/S)-1)):0);d.pageNum!=void 0&&(t=Math.min(d.pageNum,Math.max(0,Math.ceil(z/S)-1)));C.notify(q(),null,Ea);W()},getPagingInfo:q,getItems:function(){return D},setItems:function(d,h){h!==void 0&&(Ba=h);D=Aa=d;ra={};u();h=0;for(var p=D.length;h<p;h++)if(d=D[h][Ba],d===void 0||ra[d]!==h)throw"Each data element must implement a unique 'id' property";W()},setFilter:function(d){Va=
d;if(f.inlineFilters){d=Ia(Va);var h=d.body.replace(/return false\s*([;}]|$)/gi,"{ continue _coreloop; }$1").replace(/return true\s*([;}]|$)/gi,"{ _retval[_idx++] = $item$; continue _coreloop; }$1").replace(/return ([^;}]+?)\s*([;}]|$)/gi,"{ if ($1) { _retval[_idx++] = $item$; }; continue _coreloop; }$2");h="var _retval = [], _idx = 0; var $item$, $args$ = _args; _coreloop: for (var _i = 0, _il = _items.length; _i < _il; _i++) { $item$ = _items[_i]; $filter$; } return _retval; ".replace(/\$filter\$/gi,
h);h=h.replace(/\$item\$/gi,d.H[0]);h=h.replace(/\$args\$/gi,d.H[1]);d=new Function("_items,_args",h);d.displayName=d.name="compiledFilter";Xa=d;d=Ia(Va);h=d.body.replace(/return false\s*([;}]|$)/gi,"{ continue _coreloop; }$1").replace(/return true\s*([;}]|$)/gi,"{ _cache[_i] = true;_retval[_idx++] = $item$; continue _coreloop; }$1").replace(/return ([^;}]+?)\s*([;}]|$)/gi,"{ if ((_cache[_i] = $1)) { _retval[_idx++] = $item$; }; continue _coreloop; }$2");h="var _retval = [], _idx = 0; var $item$, $args$ = _args; _coreloop: for (var _i = 0, _il = _items.length; _i < _il; _i++) { $item$ = _items[_i]; if (_cache[_i]) { _retval[_idx++] = $item$; continue _coreloop; } $filter$; } return _retval; ".replace(/\$filter\$/gi,
h);h=h.replace(/\$item\$/gi,d.H[0]);h=h.replace(/\$args\$/gi,d.H[1]);d=new Function("_items,_args,_cache",h);d.displayName=d.name="compiledFilterWithCaching";Da=d}W()},sort:n,fastSort:g,reSort:function(){L?n(L,za):Wa&&g(Wa,za)},setGrouping:r,getGrouping:function(){return fa},groupBy:function(d,h,p){d==null?r([]):r({ba:d,formatter:h,Ia:p})},setAggregators:function(d,h){if(!fa.length)throw Error("At least one grouping must be specified before calling setAggregators().");fa[0].G=d;fa[0].ma=h;r(fa)},
collapseAllGroups:function(d){G(d,!0)},expandAllGroups:function(d){G(d,!1)},collapseGroup:function(d){var h=Array.prototype.slice.call(arguments),p=h[0];h.length==1&&p.indexOf(":|:")!=-1?J(p.split(":|:").length-1,p,!0):J(h.length-1,h.join(":|:"),!0)},expandGroup:function(d){var h=Array.prototype.slice.call(arguments),p=h[0];h.length==1&&p.indexOf(":|:")!=-1?J(p.split(":|:").length-1,p,!1):J(h.length-1,h.join(":|:"),!1)},getGroups:function(){return ua},getIdxById:function(d){return ra[d]},getRowById:function(d){E();
return Pa[d]},getItemById:function(d){return D[ra[d]]},getItemByIdx:function(d){return D[d]},mapRowsToIds:function(d){for(var h=[],p=0,I=d.length;p<I;p++)d[p]<xa.length&&(h[h.length]=xa[d[p]][Ba]);return h},mapIdsToRows:function(d){var h=[];E();for(var p=0,I=d.length;p<I;p++){var y=Pa[d[p]];y!=null&&(h[h.length]=y)}return h},setRefreshHints:function(d){U=d},setFilterArgs:function(d){ia=d},refresh:W,updateItem:function(d,h){if(ra[d]===void 0||d!==h[Ba])throw"Invalid or non-matching id";D[ra[d]]=h;
ya||(ya={});ya[d]=!0;W()},insertItem:function(d,h){D.splice(d,0,h);u(d);W()},addItem:function(d){D.push(d);u(D.length-1);W()},addItems:function(d){var h=D.length;Array.prototype.push.apply(D,d);u(h);W()},deleteItem:function(d){var h=ra[d];if(h===void 0)throw"Invalid id";delete ra[d];D.splice(h,1);u(h);W()},deleteItems:function(d){for(var h=[],p=0,I=d.length;p<I;++p){var y=ra[d[p].id];if(y===void 0)throw"Invalid id";h.push(y)}if(h.length){h.sort(function(F,P){return F-P});for(p=h.length-1;p>=0;--p)D.splice(h[p],
1);u(h[0]);W()}},syncGridSelection:function(d,h,p){function I(la){R.join(",")!=la.join(",")&&(R=la)}function y(){if(R.length>0){P=!0;var la=F.mapIdsToRows(R);h||I(F.mapRowsToIds(la));d.setSelectedRows(la);P=!1}}var F=this,P,R=F.mapRowsToIds(d.getSelectedRows());d.onSelectedRowsChanged.subscribe(function(){if(!P){var la=F.mapRowsToIds(d.getSelectedRows());if(p&&d.getOptions().multiSelect){var ma=c.grep(R,function(gb){return F.getRowById(gb)===void 0});I(ma.concat(la))}else I(la)}});this.onRowsChanged.subscribe(y);
this.onRowCountChanged.subscribe(y)},syncGridCellCssStyles:function(d,h){function p(P){y={};for(var R in P)y[xa[R][Ba]]=P[R]}function I(){if(y){F=!0;E();var P={},R;for(R in y){var la=Pa[R];la!=void 0&&(P[la]=y[R])}d.setCellCssStyles(h,P);F=!1}}var y,F;p(d.getCellCssStyles(h));d.onCellCssStylesChanged.subscribe(function(P,R){F||h==R.key&&R.hash&&p(R.hash)});this.onRowsChanged.subscribe(I);this.onRowCountChanged.subscribe(I)},getLength:function(){return xa.length},getItem:function(d){if((d=xa[d])&&
d.L&&d.I&&!d.I.da){var h=fa[d.level];h.Ja||(Y(d.I),d.title=h.formatter?h.formatter(d):d.value)}else d&&d.X&&!d.da&&Y(d);return d},getItemMetadata:function(d){d=xa[d];return d===void 0?null:d.L?f.groupItemMetadataProvider.Sb(d):d.X?f.groupItemMetadataProvider.Ub(d):null},onRowCountChanged:m,onRowsChanged:v,onPagingInfoChanged:C,setSearchText:function(d){wa=d},setSearchFunc:function(d){k=d},getSearchText:function(){return wa},invalidateFilterCache:function(d){for(var h=0;h<d.length;++h){var p=ra[d[h]];
p!=void 0&&(D[p].M={})}},mergeItemsUpdates:function(d){for(const h of d)d=ra[h.id],d!=void 0&&(d=D[d],Object.assign(d,h),d.M={},d.Fb=void 0,d.Gb=void 0)},reSortOne:function(d,h){if(L&&(d=ra[d],d!=void 0)){var p=D[d];D.splice(d,1);for(var I=0;I<D.length&&L(p,D[I])>0==za;++I);D.splice(I,0,p);I!=d?(u(Math.min(I,d)),W()):h&&W()}},reSortNew:function(d){if(L&&!(d>=D.length)){d=D.splice(d,D.length);for(var h=0;h<d.length;++h)d[h].index=h+D.length;return w(d)}},reSortUpdate:function(d){if(L&&d&&d.length){for(var h=
[],p=[],I=0;I<d.length;++I){var y=ra[d[I]];y!=void 0&&(h.push(y),p.push(D[y]))}h.sort(function(F,P){return F-P});for(I=h.length-1;I>=0;--I)D.splice(h[I],1);return w(p)}},updateIdxById:u,getRows:function(){return xa},validateIdxById:function(){for(var d=0,h=D.length;d<h;++d)ra[D[d].id]!=d&&alert("idxById invalid")}})},Aggregators:{Avg:function(f){this.o=f;this.init=function(){this.D=this.qa=0};this.Y=function(k){k=k[this.o];k!=null&&k!==""&&(this.qa++,this.D+=parseFloat(k))};this.ga=function(k){k.Ga||
(k.Ga={});this.qa!=0&&(k.Ga[this.o]=this.D/this.qa)}},Min:function(f){this.o=f;this.init=function(){this.fa=null};this.Y=function(k){k=k[this.o];k!=null&&k!==""&&(this.fa==null||k<this.fa)&&(this.fa=k)};this.ga=function(k){k.min||(k.min={});k.min[this.o]=this.fa}},Max:function(f){this.o=f;this.init=function(){this.ea=null};this.Y=function(k){k=k[this.o];k!=null&&k!==""&&(this.ea==null||k>this.ea)&&(this.ea=k)};this.ga=function(k){k.max||(k.max={});k.max[this.o]=this.ea}},Sum:function(f){this.o=f;
this.init=function(){this.D=null};this.Y=function(k){k=k[this.o];k!=null&&k!==""&&(this.D+=parseFloat(k))};this.ga=function(k){k.Sa||(k.Sa={});k.Sa[this.o]=this.D}}}}}})})(jQuery);
(function(c){c.extend(!0,window,{Slick:{AutoTooltips:function(f){function k(g){if((g=q.getCellNodeFromEvent(g))&&!q.getColumns()[g.cell]._notip){g=g.$cell;f.tipHandle&&(g=g.find(f.tipHandle));var w=g[0];if(w.Bb!=w.scrollWidth){if(g.innerWidth()<w.scrollWidth){var r=c.trim(g.text());f.maxToolTipLength&&r.length>f.maxToolTipLength&&(r=r.substr(0,f.maxToolTipLength-3)+"...")}else r="";w.Bb=w.scrollWidth;g.attr("title",r)}}}function u(g,w){w=w.column;g=c(g.target).closest(".slick-header-column");w.toolTip||
g.attr("title",g.innerWidth()<g[0].scrollWidth?w.name:"")}var q,n={enableForCells:!0,enableForHeaderCells:!1,maxToolTipLength:null,tipHandle:null};c.extend(this,{init:function(g){f=c.extend(!0,{},n,f);q=g;f.enableForCells&&q.onMouseEnter.subscribe(k);f.enableForHeaderCells&&q.onHeaderMouseEnter.subscribe(u)},destroy:function(){f.enableForCells&&q.onMouseEnter.unsubscribe(k);f.enableForHeaderCells&&q.onHeaderMouseEnter.unsubscribe(u)},config:function(g,w){f[g]=w}})}}})})(jQuery);
(function(c){c.extend(!0,window,{Slick:{RowSelectionModel:function(f){function k(Q){return function(){M||(M=!0,Q.apply(this,arguments),M=!1)}}function u(Q){for(var V=[],N=0;N<Q.length;N++)for(var B=Q[N].fromRow;B<=Q[N].toRow;B++)V.push(B);return V}function q(Q){for(var V=[],N=J.getColumns().length-1,B=0;B<Q.length;B++)V.push(new Slick.Range(Q[B],0,Q[B],N));return V}function n(Q,V){var N,B=[];for(N=Q;N<=V;N++)B.push(N);for(N=V;N<Q;N++)B.push(N);return B}function g(){return u(ba)}function w(Q){ba=Q;
Y.onSelectedRangesChanged.notify(ba)}function r(Q,V){Ia.selectActiveRow&&V.row!=null&&w([new Slick.Range(V.row,0,V.row,J.getColumns().length-1)])}function E(Q){var V=J.getActiveCell();if(V&&Q.shiftKey&&!Q.ctrlKey&&!Q.altKey&&!Q.metaKey&&(Q.which==38||Q.which==40)){var N=g();N.sort(function(W,Ea){return W-Ea});N.length||(N=[V.row]);var B=N[0];N=N[N.length-1];V=Q.which==40?V.row<N||B==N?++N:++B:V.row<N?--N:--B;V>=0&&V<J.getDataLength()&&(J.scrollRowIntoView(V),ba=q(n(B,N)),w(ba));Q.preventDefault();
Q.stopPropagation()}}function G(Q){var V=J.getCellFromEvent(Q);if(!(V&&J.canCellBeActive(V.row,V.cell)&&J.getOptions().multiSelect&&(Q.ctrlKey||Q.shiftKey||Q.metaKey)))return!1;var N=u(ba),B=c.inArray(V.row,N);if(B===-1&&(Q.ctrlKey||Q.metaKey))N.push(V.row),J.setActiveCell(V.row,V.cell);else if(B!==-1&&(Q.ctrlKey||Q.metaKey))N=c.grep(N,function(Ba){return Ba!==V.row}),J.setActiveCell(V.row,V.cell);else if(N.length&&Q.shiftKey){B=N.pop();var W=Math.min(V.row,B),Ea=Math.max(V.row,B);for(N=[];W<=Ea;W++)W!==
B&&N.push(W);N.push(B);J.setActiveCell(V.row,V.cell)}ba=q(N);w(ba);Q.stopImmediatePropagation();return!0}var J,ba=[],Y=this,qa=new Slick.EventHandler,M,Ia,va={selectActiveRow:!0};c.extend(this,{getSelectedRows:g,setSelectedRows:function(Q){w(q(Q))},getSelectedRanges:function(){return ba},setSelectedRanges:w,init:function(Q){Ia=c.extend(!0,{},va,f);J=Q;qa.subscribe(J.onActiveCellChanged,k(r));qa.subscribe(J.onKeyDown,k(E));qa.subscribe(J.onClick,k(G))},destroy:function(){qa.unsubscribeAll()},onSelectedRangesChanged:new Slick.Event})}}})})(jQuery);
(function(c){c.extend(!0,window,{Slick:{CheckboxSelectColumn:function(f){function k(G){G?c("#cbox_all_header").prop("checked",!0):c("#cbox_all_header").prop("checked",!1)}function u(){for(var G=0,J=w.getDataLength()-1;G<=J;++G,--J)if(!w.getDataItem(G).sel||!w.getDataItem(J).sel){k(!1);return}k(!0)}function q(G,J){if(w.getColumns()[J.cell].id===E.columnId&&c(G.target).is(":checkbox")){if(w.getEditorLock().isActive()&&!w.getEditorLock().commitCurrentEdit())G.preventDefault();else{var ba=G.target.checked,
Y=1,qa=w.getSelectionModel().getSelectedRows();if(qa.indexOf(J.row)!=-1){J=Y=0;for(var M=qa.length;J<M;++J)w.getDataItem(qa[J]).sel!=ba&&(w.getDataItem(qa[J]).sel=ba,++Y);Y>1&&(w.invalidateRows(qa),w.render())}else w.getDataItem(J.row).sel=ba;c(G.target).closest(".slick-row").toggleClass("checked_row",ba);G.target.checked?u():k(!1);if(E.onCheck)E.onCheck(ba?Y:-Y);G.stopPropagation()}G.stopImmediatePropagation()}}function n(G,J){if(J.column.id==E.columnId&&c(G.target).is(":checkbox")){J=G.target.checked;
for(var ba=0,Y=w.getDataLength();ba<Y;ba++)w.getDataItem(ba).sel=J;w.invalidateAllRows();w.render();if(E.onCheckAll)E.onCheckAll(J);G.stopPropagation();G.stopImmediatePropagation()}}function g(G,J,ba,Y,qa){return qa?(setTimeout(function(){var M=w.getRowNode(G);M&&c(M).toggleClass("checked_row",ba)},0),ba?"<input type='checkbox' checked='checked'>":"<input type='checkbox'>"):null}var w,r=new Slick.EventHandler,E=c.extend(!0,{},{columnId:"_checkbox_selector",cssClass:null,width:30,onCheck:null,onCheckAll:null},
f);c.extend(this,{init:function(G){w=G;r.subscribe(w.onClick,q).subscribe(w.onHeaderClick,n)},destroy:function(){r.unsubscribeAll()},getColumnDefinition:function(){return{id:E.columnId,name:"<input id='cbox_all_header' type='checkbox'>",toolTip:E.toolTip,field:"sel",width:E.width,resizable:!1,sortable:!1,cssClass:E.cssClass,formatter:g,_noactive:!0,_nofit:!0}},initData:function(G){for(var J=0,ba=G.length;J<ba;++J)G[J].sel=!1},getCheckedRows:function(){for(var G=[],J=0,ba=w.getDataLength();J<ba;J++)w.getDataItem(J).sel==
1&&G.push(J);return G},getCheckedRowsCount:function(){for(var G=0,J=0,ba=w.getDataLength();J<ba;J++)w.getDataItem(J).sel==1&&++G;return G},setCheckedRows:function(G,J,ba){if(ba==1)for(var Y=0,qa=w.getDataLength();Y<qa;Y++)w.getDataItem(Y).sel=!1;Y=0;for(qa=G.length;Y<qa;Y++)w.getDataItem(G[Y]).sel=J;ba==1?(w.invalidateAllRows(),k(J&&G.length==w.getDataLength())):(w.invalidateRows(G),J?u():G.length>0&&k(!1));w.render()},recheckFull:u,isFullChecked:function(){return c("#cbox_all_header").prop("checked")}})}}})})(jQuery);
(function(c){c.fn.numeric=function(f,k){typeof f==="boolean"&&(f={decimal:f});f=f||{};typeof f.negative=="undefined"&&(f.negative=!0);var u=f.decimal===!1?"":f.decimal||".";f=f.negative===!0?!0:!1;k=typeof k=="function"?k:function(){};return this.data("numeric.decimal",u).data("numeric.negative",f).data("numeric.callback",k).keypress(c.fn.numeric.keypress).keyup(c.fn.numeric.keyup).blur(c.fn.numeric.blur)};c.fn.numeric.keypress=function(f){var k=c.data(this,"numeric.decimal"),u=c.data(this,"numeric.negative"),
q=f.charCode?f.charCode:f.keyCode?f.keyCode:0;if(q==13&&this.nodeName.toLowerCase()=="input")return!0;if(q==13)return!1;var n=!1;if(f.ctrlKey&&q==97||f.ctrlKey&&q==65||f.ctrlKey&&q==120||f.ctrlKey&&q==88||f.ctrlKey&&q==99||f.ctrlKey&&q==67||f.ctrlKey&&q==122||f.ctrlKey&&q==90||f.ctrlKey&&q==118||f.ctrlKey&&q==86||f.shiftKey&&q==45)return!0;if(q<48||q>57){var g=c(this).val();if(g.indexOf("-")!==0&&u&&q==45&&(g.length===0||parseInt(c.fn.Tb(this),10)===0))return!0;k&&q==k.charCodeAt(0)&&g.indexOf(k)!=
-1&&(n=!1);q!=8&&q!=9&&q!=13&&q!=35&&q!=36&&q!=37&&q!=39&&q!=46?n=!1:typeof f.charCode!="undefined"&&(f.keyCode==f.which&&f.which!==0?(n=!0,f.which==46&&(n=!1)):f.keyCode!==0&&f.charCode===0&&f.which===0&&(n=!0));k&&q==k.charCodeAt(0)&&(n=g.indexOf(k)==-1?!0:!1)}else n=!0;return n};c.fn.numeric.keyup=function(){var f=c(this).val();if(f&&f.length>0){var k=c.data(this,"numeric.decimal"),u=c.data(this,"numeric.negative");if(k!==""&&k!==null){var q=f.indexOf(k);q===0&&(this.value="0"+f);q==1&&f.charAt(0)==
"-"&&(this.value="-0"+f.substring(1));f=this.value}var n=[0,1,2,3,4,5,6,7,8,9,"-",k];q=f.length;for(var g=q-1;g>=0;g--){var w=f.charAt(g);g!==0&&w=="-"?f=f.substring(0,g)+f.substring(g+1):g!==0||u||w!="-"||(f=f.substring(1));for(var r=!1,E=0;E<n.length;E++)if(w==n[E]){r=!0;break}r&&w!=" "||(f=f.substring(0,g)+f.substring(g+1))}u=f.indexOf(k);if(u>0)for(--q;q>u;q--)f.charAt(q)==k&&(f=f.substring(0,q)+f.substring(q+1));this.value=f}};c.fn.numeric.blur=function(){function f(n){if(n.max&&parseInt(n.value)>
parseInt(n.max))n.value=n.max;else if(n.min)n.value=n.min;else return;c(n).change()}var k=c.data(this,"numeric.decimal"),u=c.data(this,"numeric.callback"),q=this.value;q!==""?(new RegExp("^\\d+$|^\\d*"+k+"\\d+$")).exec(q)&&this.validity.valid||(f(this),u.apply(this)):(f(this),u.apply(this))};c.fn.Zb=function(){return this.data("numeric.decimal",null).data("numeric.negative",null).data("numeric.callback",null).unbind("keypress",c.fn.numeric.keypress).unbind("blur",c.fn.numeric.blur)}})(jQuery);
globalThis.addEventListener("error",c=>{(c=dd(c.error))&&fe(137,"page_referrer",c)},!0);globalThis.addEventListener("unhandledrejection",c=>{(c=dd(c.reason))&&fe(138,"page_referrer",c)});var sc="",se=-1;
(function(){function c(){function L(t){var z=N[D];return D==t.icat&&(z.u==0||t.size==-1||t.size>=z.v)}function U(t){return D==t.icat}function ja(t,z){if(!t||t.startsWith("data:"))setTimeout(function(){z(-2)},0);else{var m=new XMLHttpRequest,v=++Pa;ra[v]=m;m.open("HEAD",t,!0);m.onreadystatechange=function(){if(this.readyState==this.DONE){let C=Number(m.getResponseHeader("Content-Length"));if(isNaN(C)||!isFinite(C))C=-2;z(C)}delete ra[v]};m.onerror=function(){z(-2);console.log("Error",m.statusText);
delete ra[v]};m.send()}}function ia(t){$('[name="'+t+'"]').change(function(){if(M){var z=Nb($(this).val()),m=Q.getSelectedRows();if(m.length){for(var v=0,C=m.length;v<C;++v)M.getDataItem(m[v])[t]=z;M.beginRender();M.invalidateRows(m);z=M.getSortColumns();z.length>0&&ua[z[0].columnId]==t&&va.reSortUpdate(va.mapRowsToIds(m));M.endRender()}}})}function Aa(){var t=Q.getSelectedRows();if(t.length==0){for(t=0;t<aa.length;++t)$('[name="'+aa[t][0]+'"]').val("").removeAttr("placeholder");$(".dy_new_task_dlg input, .dy_new_task_dlg textarea, .dy_new_task_dlg select").attr("disabled",
"disabled")}else if($(".dy_new_task_dlg input, .dy_new_task_dlg textarea, .dy_new_task_dlg select").removeAttr("disabled"),t.length==1){var z=M.getDataItem(t[0]);for(t=0;t<aa.length;++t){var m=aa[t][0],v=aa[t][1];$('[name="'+m+'"]').val(z[m]).attr("placeholder",v)}}else if(t.length>1)for(t=0;t<aa.length;++t)$('[name="'+aa[t][0]+'"]').val("").attr("placeholder",K("phraseMultiValues"))}function Xa(){const t=[];if(!$(r.K).is(":checked"))for(var z=E.find(".active_exts input:checkbox:checked"),m=z.length,
v=0,C=M.getDataLength();v<C;++v)for(var d=M.getDataItem(v),h=0;h<m;++h)if(d.fext==z[h].attributes.fext.value){t.push(v);break}if(S)for(z=0,m=M.getDataLength();z<m;++z)S.test(M.getDataItem(z).url)&&t.push(z);Ia.setCheckedRows(t,!0,!0);u(D,t.length)}function Da(t,z){const m=$("[name=addtop]").prop("checked"),v=[],C=async F=>{v.length>0&&await Promise.all(v);z(F)},d=[],h={};for(var p=0,I=V.length;p<I;++p){var y=V[p];y.sel==1&&(N[y.icat].u==0||y.size==-1||y.size>=N[y.icat].v)&&(d.push({url:Nb(y.url),
naming:y.naming?(y.naming||"").trim().replace(/(^(\\|\/|\.)+)|((\\|\/|\.)+$)/g,"").replace(/\s*(\\|\/)+\s*/g,"/").trim():void 0,referer:Nb(y.referer),desc:Nb(y.desc),title:Nb(y.title),text:Nb(y.text)}),y=y.oa||"_",h[y]=(h[y]||0)+1)}d.length?(v.push(Jd(h)),chrome.tabs.sendMessage(se,{cmd:"g_title"},function(F){kb({cmd:"new_task",add_paused:t,addtop:m,tasks:d,page_title:F||"",source:77},()=>{C&&C(!0)})}),v.push(Id(d.length))):C&&C(!1)}function Ka(t,z,m){z=="size"?t.sort(function(v,C){if(v.size<0){if(C.size<
0){var d=v.size-C.size;return d?m?d:-d:v.index-C.index}return m?1:-1}return C.size<0?m?-1:1:v.size-C.size||v.index-C.index},m):z=="sel"?t.sort(function(v,C){return v.sel-C.sel||v.index-C.index},m):t.sort(function(v,C){return(v[z]||"").localeCompare(C[z]||"")||v.index-C.index},m)}E=$(r.va);ba=Array(G.length);for(var wa=0,mb=G.length;wa<mb;++wa)G[wa].filter_links&&(ba[wa]=new RegExp("^("+ne(wa)+")$","i"));wa=1;Y=[{id:String(wa++),name:K("fieldURL"),field:"url",sortable:!0,cssClass:"slick-cell-left",
formatter:(t,z,m,v,C)=>!Ea||Ba?m:C.preview=="audio"?'<div class="audplayer"><audio src="'+m+'"/></div>':C.preview=="img"?'<img src="'+m+'"/>':m?m.length>256?m.substr(0,256)+"...":m:""},{id:String(wa++),name:K("fieldType"),field:"fext",sortable:!0,cssClass:"slick-cell-center"},{id:String(wa++),name:K("fieldRemarks"),field:"desc",sortable:!0,cssClass:"slick-cell-center"},{id:String(wa++),name:K("fieldNaming"),field:"naming",sortable:!1,cssClass:"slick-cell-center"}];var fa={id:String(wa++),name:K("fieldFileSize"),
field:"size",sortable:!0,cssClass:"slick-cell-center",formatter:(t,z,m,v,C)=>m>=0?tc(m):m==-1?(C.hb||ja(C.url,function(d){if(J){C.size=d;if(D==C.icat){var h=va.getRowById(C.id);h!=void 0&&M.updateCell(h,3);(h=M.getSortColumns()[0])&&h.columnId==fa.id?va.reSortOne(C.id):va.refresh()}h=N[C.icat];d>0&&(h.aa.push(d),D==C.icat&&k(D));C.sel&&h.u>0&&d<h.v&&u(D,Ia.getCheckedRowsCount())}}),C.hb=!0,'<img src="/icons/sniffer/img_loading.gif"/>'):"-"},ua={};qa={explicitInitialization:!0,enableColumnReorder:!1,
forceFitColumns:!1,fullWidthRows:!0,editable:!1,autoEdit:!1};var aa=[["naming",K("phraseAutomatic")],["desc",""]],S=null;(function(){Ia=new Slick.CheckboxSelectColumn({cssClass:"slick-cell-center",onCheck:function(m){m>0?u(D,m,1):u(D,-m,-1)},onCheckAll:function(m){m?u(D,M.getDataLength()):u(D,0);$(".active_exts input:checkbox").prop("checked",m)}});Y.unshift(Ia.getColumnDefinition());for(var t=0;t<Y.length;++t)ua[Y[t].id]=Y[t].field;ua[fa.id]=fa.field;Xd.get("pop_showsize")==1&&($(r.ua).prop("checked",
!0),Y.splice(3,0,fa),$(r.F).show());Xd.get("pop_preview")==1&&($(r.V).prop("checked",!0),f(!0,!1));const z=new Slick.Data.DataView;M=new Slick.Grid(r.Grid,z,Y,qa);M.registerPlugin(new Slick.AutoTooltips({enableForHeaderCells:!0,enableForCells:!0,maxToolTipLength:256}));t=new Slick.RowSelectionModel;t.onSelectedRangesChanged.subscribe(Aa);M.setSelectionModel(t);M.registerPlugin(Ia);Q=t;M.onMouseEnter.subscribe(function(m){if(Ea&&(m=M.getCellNodeFromEvent(m))&&Y[m.cell].field=="url"){var v=m.$cell,
C=v.find("img");if(C.length!=0){var d=v.height(),h=v.width();C[0].naturalWidth<=h&&C[0].naturalHeight<=d||(C=v.outerHeight(),d=v.outerWidth(),v=v.offset(),$(r.U+" img").attr("src",M.getDataItem(m.row).url),m=$(r.U).show().height(),$(r.U).css("left",v.left+d).css("top",Math.max(0,v.top+C/2-m/2)))}}});M.onMouseLeave.subscribe(function(){Ea&&$(r.U).hide()});M.onSort.subscribe(function(m,v){Ka(z,v.sortCol.field,v.sortAsc)});M.onClick.subscribe(function(m){var v=$(m.target);v.hasClass("audplayer")&&(m=
m.target.firstChild,v.data("evtattached")!=1&&(m.addEventListener("ended",function(){this.currentTime=0;this.pause();$(this).parent().removeClass("audpause")}),v.data("evtattached",!0)),m.paused==0?(m.pause(),v.removeClass("audpause")):($("audio").each(function(){this.pause();$(this).parent().removeClass("audpause")}),m.play(),v.addClass("audpause")))});z.onRowCountChanged.subscribe(function(m,v){M.updateRowCount();v.diffRows&&v.diffRows.length||M.render()});z.onRowsChanged.subscribe(function(m,v){M.invalidateRows(v.rows);
M.render()});z.syncGridSelection(M,!1);M.enableColumnFit();va=z})();va.beginUpdate();va.setItems(V);va.setFilter(Xd.get("pop_showsize")?L:U);va.endUpdate();(function(){for(var t=0;t<aa.length;++t)ia(aa[t][0]);Aa();qe()})();(function(){$(r.ua).change(function(){this.checked?(Y[3].field!="size"&&Y.splice(3,0,fa),$(r.F).show()):(Y[3].field=="size"&&Y.splice(3,1),$(r.F).hide());Xd.set("pop_showsize",this.checked);M.beginRender();M.setColumns(Y);va.setFilter(this.checked?L:U);M.endRender()});$(r.V).change(function(){f(this.checked,
!0,!0);Xd.set("pop_preview",this.checked)});$(r.F).mouseenter(function(){$(r.T).show()}).mouseleave(function(){$(r.T).hide()});$(r.F+' input[type="range"]').bind("input",function(){var t=parseInt(this.value);N[D].u=t;if(t<=0||t>50)var z=0;else if(z=N[D],z.l.length==0)z=0;else{var m=(t-1)*(z.l.length-1)/49,v=Math.floor(m);z=v>=z.l.length-1?z.l[z.l.length-1]:z.l[v]+(z.l[v+1]-z.l[v])*(m-v)}N[D].v=z;$(r.T).text(t?"> "+tc(z):"-");va.refresh();u(D,Ia.getCheckedRowsCount())});$(document).on("click",".filter_tab",
function(){var t=$(".active_tab.filter_tab");t.length!=0&&(t.data("RE",$(r.J).val()||""),t.data("exclusive",$(r.K).prop("checked")),t.data("sortcols",M.getSortColumns()),t.removeClass("active_tab"));t=$(this);var z=t.data("RE")||"";$(r.J).val(z);z=t.data("exclusive")||!1;$(r.K).prop("checked",z);z=t.data("sortcols")||[];var m=M.getSortColumns();m=z.length>0&&(m.length==0||z[0].columnId!=m[0].columnId||z[0].sortAsc!=m[0].sortAsc);M.setSortColumns(z);t.addClass("active_tab");D=Number(t.attr("icat"));
t=!1;N[D].S?($(r.W).show(),t=$(r.V).prop("checked")):$(r.W).hide();M.beginRender();m?Ka(va,ua[z[0].columnId],z[0].sortAsc):va.refresh();f(t,!0,!1);M.endRender();Ia.recheckFull();t=$(r.F+' input[type="range"]')[0];z=N[D];t.min="0";t.max="50";t.value=String(z.u);$(r.T).text(z.u?"> "+tc(z.v):"-");k(D);E.find('div[icat="'+D+'"]').addClass("active_exts").siblings().removeClass("active_exts");xa=1});$(document).on("click",r.va+" input:checkbox",function(){if(!$(r.K).is(":checked")){for(var t=this.attributes.fext.value,
z=this.checked,m=[],v=0,C=M.getDataLength();v<C;++v)M.getDataItem(v).fext==t&&m.push(v);Ia.setCheckedRows(m,z);u(D,Ia.getCheckedRowsCount())}});$(r.xa+" li").click(function(){$(r.xa+" .active_tab").removeClass("active_tab");$(".settings_active").removeClass("settings_active");$(this).addClass("active_tab");$("#"+$(this).attr("tab-target")).addClass("settings_active")});$(r.J).bind("input",function(){var t=Nb($(this).val());if(t=="")S=null;else{$(r.J).removeAttr("style");console.log(t);try{var z=new RegExp(t,
"i")}catch(m){console.log(m),$(r.J).attr("style","border: 1px solid rgb(255, 0, 0);")}S=z}Xa()});$(r.K).bind("change",function(){this.checked?E.find(".active_exts input:checkbox").attr("disabled","disabled"):E.find(".active_exts input:checkbox").removeAttr("disabled");Xa()});$(r.sa).click(function(){Da(!1,function(t){t&&window.close()})});$(r.ra).click(function(){Da(!0,function(t){t&&window.close()})});$(r.Ta).click(function(){window.close()});$("input[type=number]").numeric({decimal:!1,negative:!1});
Xd.get("def_addtop")&&$("[name=addtop]").prop("checked",!0);$(r.Ua).click(function(){kb({cmd:"open_options",section:"category"})})})();M.beginRender();M.init();M.autosizeColumns();M.endRender()}function f(L,U,ja){if(Ea!=L){if(Ea=L){qa.rowHeight=64;for(var ia=0;ia<Y.length;++ia)if(Y[ia].field=="url"){Y[ia].cssClass="slick-cell-center";break}}else for(qa.rowHeight=25,ia=0;ia<Y.length;++ia)if(Y[ia].field=="url"){Y[ia].cssClass="slick-cell-left";break}$(r.Grid).toggleClass("grid-preview",L);U!=0&&M&&
(ja&&M.beginRender(),M.setOptions(qa),M.setColumns(Y),ja&&M.endRender())}}function k(L){L=N[L];var U=new Set;for(var ja of L.aa)U.add(ja);ja=Array.from(U);U=ja.length;L.l=[];ja.sort(function(Aa,Xa){return Aa-Xa});if(U<=10)for(var ia=0;ia<U;++ia)L.l.push(ja[ia]-.1);else for(L.l.push(ja[0]-.1),ia=1;ia<10;++ia)L.l.push(ja[Math.floor(ia*(U-1)/9)]-.1)}function u(L,U,ja){L=$('.filter_tab[icat="'+L+'"]');if(ja){var ia=L.data("sel_cnt")||0;U=ja>0?ia+U:ia-U}ja="";U>0&&(ja=" ("+U+")");L.data("sel_cnt",U);L.find(".tab_selcount").text(ja);
U=$(".filter_tab");for(L=ja=0;L<U.length;++L)ja+=U.eq(L).data("sel_cnt")||0;$(r.sa).prop("disabled",ja==0);$(r.ra).prop("disabled",ja==0)}function q(L){switch(L.cmd){case "add_links":n(L.data),$(r.bb).hide()}}function n(L){function U(m){for(var v=E.find('div[icat="'+m.icat+'"] input:checkbox:checked'),C=v.length,d=0;d<C;++d)if(m.fext==v[d].attributes.fext.value)return!0;return!1}function ja(m){for(var v=m!=9999?G[m].caption:K("extsOthers"),C="filter_tab",d=$(".filter_tab"),h=d.length-1;h>=0;--h){var p=
Number($(d[h]).attr("icat"));if(m>p)break}h<0?(xa||(C+=" active_tab",D=m,d.removeClass("active_tab")),v='<li class="'+C+'" icat="'+m+'"><a href="#">'+v+'<span class="tab_selcount"></span></a></li>',$(r.ab).prepend(v)):(v='<li class="'+C+'" icat="'+m+'"><a href="#">'+v+'<span class="tab_selcount"></span></a></li>',$(d[h]).after(v));d='<div icat="'+m+'"';D==m&&(E.find("div").removeClass("active_exts"),d+=' class="active_exts"');E.append(d+"><ul></ul></div>")}function ia(m,v){v='<li><label><input type="checkbox"  fext="'+
v+'"><span>'+(v||".")+" ("+B[m][v]+")</span></label></li>";var C=E.find('div[icat="'+m+'"] li:last-child');C.length==0||C.find("input").attr("fext")!=""?E.find('div[icat="'+m+'"] ul').append(v):C.before(v)}function Aa(m){if(!m||!ba)return 9999;for(var v=0,C=G.length;v<C;++v)if(ba[v]&&ba[v].test(m))return v;return 9999}if(L&&L.length){for(var Xa=V.length,Da={},Ka={},wa=[],mb=!1,fa=0,ua=L.length;fa<ua;++fa){const m=L[fa];var aa=m.fext||qc(oc(m.url).file).oa||qc(m.desc).oa;aa&&aa.length>20&&(aa="");
if(!Va.test(sc)||!ya.test(aa)){var S=W[m.url];if(S!=void 0){if(m.desc||m.title||m.text)if(aa=va.getItemById(S))m.title||m.text?(aa.desc=aa.desc||m.desc||m.text||m.title,aa.text=aa.text||m.text,aa.title=aa.title||m.title):aa.desc=m.desc}else{m.referer=sc;m.desc=m.desc||m.text||m.title;S=Aa(aa);B[S]||(B[S]={},ja(S));B[S][aa]||(B[S][aa]=0,ia(S,aa));++B[S][aa];m.id=Xa+fa;m.index=m.id;m.icat=S;m.fext=aa;m.size&&m.size!=-1?(N[S].aa.push(m.size),S==D&&(mb=!0)):m.size=-1;var t=U(m);m.sel=t;var z=N[S];t&&
(z.u==0||m.size==-1||m.size>=z.v)&&(Ka[S]?++Ka[S]:Ka[S]=1);Da[S]||(Da[S]={});Da[S][aa]=1;Ta.test(aa)?(m.preview="img",N[S].S=!0):za.test(aa)&&(m.preview="audio",N[S].S=!0);wa.push(m);W[m.url]=m.id}}}L=!1;N[D].S?($(r.W).show(),L=$(r.V).prop("checked")):$(r.W).hide();Ba=!1;M.beginRender();f(L,!0,!1);va.addItems(wa);M.endRender();for(const m in Da)for(const v in Da[m])E.find('input[fext="'+v+'"]').siblings().text((v||".")+" ("+B[m][v]+")");for(const m in Ka)u(m,Ka[m],1);mb&&k(D)}}function g(){$(r.Va).click(function(){kb({cmd:"open_ui"},
function(){window.close()})});$(r.Wa).click(function(){Xd.set("pop_content",0);window.location.href="pop.html"});je.set("stid",se);try{rc()&&Wa.test(sc)==0?($(r.wa).hide(),$(r.ta).show(),$(r.ya).addClass("wider"),Promise.all([Yd,oe.load()]).then(()=>{G=le;c();var L=se;Ea=!1;Ba=!0;D=-1;xa=0;chrome.runtime.onMessage.addListener(q);Pa=0;ra={};N={};B={};W={};V.splice(0,V.length);va.refresh();N[9999]={S:!1,u:0,v:0,l:[],aa:[]};for(var U=0,ja=G.length;U<ja;++U)N[U]={S:!1,u:0,v:0,l:[],aa:[]};chrome.tabs.sendMessage(L,
{cmd:"g_links"});J=!0;location.search.includes("mnu=1")&&Xd.get("pop_content")===0&&chrome.action.setPopup({popup:"/pop/pop.html"})})):($(r.ta).hide(),$(r.wa).show(),$(r.ya).removeClass("wider"))}catch(L){console.log(L)}}function w(){var L=document.getElementById(r.cb),U=document.getElementById(r.Xa),ja=document.getElementById(r.gb),ia=document.getElementById(r.Ya);rc()&&Wa.test(sc)==0?(U.style.display="block",ja.className="wider"):L.style.display="block";ia.style.display="block";ge();Zd();document.body.ondragstart=
()=>!1;document.body.ondrop=()=>!1;re()}var r={U:"#img_enlarge",Grid:"#links_grid",bb:"#wrap_sniffer_loading",xa:"#settings_tabs",ab:"#filter_tabs",J:"#filter_custom",K:"#filter_exclusive",va:"#ext_filters",sa:"#btn_start",ra:"#btn_addpause",Ta:"#btn_cancel",Ua:"#config_cats",ua:"#cb_show_size",F:"#slider_filesize",T:"#text_filesize",V:"#cb_preview",W:"#cb_preview_wrap",gb:"tot_wrap",cb:"cannot_sniffer",Xa:"can_sniffer",Ya:"wrap_sniffer",ya:"#tot_wrap",wa:"#cannot_sniffer",ta:"#can_sniffer",Va:"#btn_manager",
Wa:"#btn_list"},E,G=[],J=!1,ba=null,Y,qa,M=null,Ia=null,va=null,Q=null,V=[],N={},B={},W={},Ea=!1,Ba=!0,D=-1,xa=0,ra={},Pa=0,Va=RegExp(".*youtube.com.*","i"),ya=RegExp("^(3gp|3g2|asf|avi|f4f|f4i|f4m|f4v|flv|h264|m4v|mkv|mov|mp4|mpg|ogg|ogv|qt|rm|rmvb|ts|vob|webm|wmv)$","i"),Ta=RegExp("^(jpe?g|gif|png|bmp|ico|webp|svg)$","i"),za=RegExp("^(m4a|mp3|oga|ogg|opus|wav|weba)$","i");window.onunload=function(){je.erase("stid")};var Wa=/chromewebstore\.google\.com|chrome\.google\.com\/webstore/;window.addEventListener("load",
function(){pe>1740009692193||chrome.tabs.query({currentWindow:!0,active:!0},function(L){L&&L.length&&(sc=L[0].url,se=L[0].id);w();g();de("page_view",{page_title:document.title,page_location:location.href});kb({cmd:"gr"})})})})();
